;------------------------------------------------------------------------------
; Eclipse 1.0.0 installation script
;	All output message will be written to file ..\..\..\..\eclipse.log
;------------------------------------------------------------------------------
#!define VERSION "5.1" ;Define your own software name here
#!define RELEASE "1" ; need for building with makensisw.exe
!define ECLIPSE_VERSION "2.0" ;Define your own software name here
!define VERSION_PLUGIN "1.0.0" ;Define your own software name here
;--------------------------------
;Version Information
  VIProductVersion "2.0.0.0"
;--------------------------------
!define MUI_PRODUCT "Kelp ${VERSION} for Eclipse ${ECLIPSE_VERSION}" ;Define your own software name here
!define MUI_VERSION "${ECLIPSE_VERSION}" ;Define your own software version here
!define MUI_NAME "${MUI_PRODUCT}"

!define MUI_ICON "${NSISDIR}\Contrib\Icons\enhydra1-install.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Icons\enhydra1-uninstall.ico"

# defines SF_*, SECTION_OFF and some macros
!include Sections.nsh

!define MUI_UNTEXT_INTRO_TITLE "Uninstall ${MUI_PRODUCT}"
!define MUI_UNTEXT_INTRO_SUBTITLE "Remove ${MUI_PRODUCT} from your computer."

!include "MUI.nsh"
;------------------------------------------------------------------------------
;Configuration
;------------------------------------------------------------------------------
  !define MUI_WELCOMEPAGE
  !define MUI_LICENSEPAGE
  !define MUI_DIRECTORYPAGE
  
  !define MUI_ABORTWARNING

  !define MUI_CUSTOMPAGECOMMANDS
  
  !define MUI_UNINSTALLER
  !define MUI_UNCONFIRMPAGE

  !define TEMP1 $R0
  !define TEMP2 $R1
    
# Language
  !define MUI_BRANDINGTEXT "Kelp Windows Installation "
  !insertmacro MUI_LANGUAGE "English"

# General
  OutFile "..\..\..\..\distribution\Kelp-eclipse${ECLIPSE_VERSION}-${VERSION}-${RELEASE}.setup.exe"

# Install Options pages
# LANG_ENGLISH
# Header
    LangString TEXT_IO_TITLE ${LANG_ENGLISH} "Please select the appropriate directories"
    LangString TEXT_IO_SUBTITLE ${LANG_ENGLISH} "Click button on right side to set the appropriate directories :"
# Window titles
    LangString TEXT_IO_PAGETITLE_A ${LANG_ENGLISH} ": Set the appropriate directories"
    LangString TEXT_IO_PAGESUBTITLE_A ${LANG_ENGLISH} "Select Enhydra directory:"
    LangString TEXT_IO_PAGECUSTOM_A ${LANG_ENGLISH} "${MUI_PRODUCT} Setup"
    LangString TEXT_IO_PAGETITLE_A ${LANG_ENGLISH} ""

# Page order 
	!insertmacro MUI_PAGE_WELCOME
	!insertmacro MUI_PAGE_LICENSE
  Page custom SetCustomPage "" "$(TEXT_IO_PAGETITLE_A)"
  !insertmacro MUI_PAGE_DIRECTORY
  !insertmacro MUI_PAGE_INSTFILES
  
# License page
  LicenseData /LANG=${LANG_ENGLISH} "${NSISDIR}\Contrib\License\LicenseEnglish.txt"

# Component-selection page
    ;Titles
    LangString TITLE_SecCopyUI ${LANG_ENGLISH} "Eclipse"

# Descriptions
    LangString DESC_SecCopyUI ${LANG_ENGLISH} "Install Eclipse ${ECLIPSE_VERSION} to the application folder."

# Folder-selection page
  InstallDir "C:\"
  
# Things that need to be extracted on startup (keep these lines before any File command!)
# Only useful for BZIP2 compression
# Use ReserveFile for your own Install Options ini files too!
  !insertmacro MUI_RESERVEFILE_INSTALLOPTIONS
  ReserveFile "eclipse.ini"
;------------------------------------------------------------------------------
;Modern UI System
;------------------------------------------------------------------------------
;------------------------------------------------------------------------------
;Installer Sections
;------------------------------------------------------------------------------
Section $(TITLE_SecCopyUI) SecCopyUI

  SetOutPath "$INSTDIR"
#  File /r "..\..\..\..\modules\Eclipse\plugins"
  File /r "..\..\Eclipse\*.*"
  
  ; replace char '\' with char '/' at Eclipse directory string
	StrCpy $1 $INSTDIR
  Push "$1"
  Push "\"
  Push "/"
	Call ReplaceChar
	Pop $1

  !insertmacro MUI_INSTALLOPTIONS_READ $2 "eclipse.ini" "Field 2" "State" ;Enhydra directory
  !insertmacro MUI_INSTALLOPTIONS_READ $3 "eclipse.ini" "Field 4" "State" ;JDK directory

	FileOpen $8 $INSTDIR\setEasRoot.bat w
	FileWrite $8 "@echo off$\r$\n"
	FileWrite $8 "set JAVA=$3\bin\java.exe$\r$\n"
	FileWrite $8 "set ENHYDRA_ROOT=$2$\r$\n"
	FileWrite $8 "set PLUGIN_ROOT=$1/plugins/org.enhydra.kelp.eclipse_${VERSION_PLUGIN}$\r$\n$\r$\n"
	FileWrite $8 "%JAVA% -cp %CLASSPATH%;%PLUGIN_ROOT%/toolbox.jar org.enhydra.tool.InitEnhydraRoot %ENHYDRA_ROOT%$\r$\n"
	FileClose $8
			
#	CopyFiles "$2\lib\build\toolbox.jar" "$INSTDIR\plugins\org.enhydra.eclipse_${VERSION_PLUGIN}"	; copy file toolbox.jar to installation directory

  ClearErrors
#  ExecWait '"$INSTDIR\setEasRoot.bat"' $0	; call configuration file
	nsExec::ExecToLog '"$INSTDIR\setEasRoot.bat"'
	Pop $0                                                ; return value/error/timeout
	Pop $1                                                ; return value/error/timeout
  StrCmp $0 "0" success
	Goto success

	DetailPrint "Enhydra Plugin for Eclipse ${VERSION_PLUGIN} failed (output: $0)"
	Call Cleanup
	Goto end

	success:
	DetailPrint "Enhydra Plugin for Eclipse ${VERSION_PLUGIN} succeded (output: $0)"

  ; Write the installation path into the registry
  WriteRegStr HKLM "SOFTWARE\Kelp ${VERSION} for Eclipse ${ECLIPSE_VERSION}" "Install_Dir" "$INSTDIR"

  ; Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Kelp ${VERSION} for Eclipse ${ECLIPSE_VERSION}" \
                   "DisplayName" "Kelp ${VERSION} for Eclipse ${ECLIPSE_VERSION} (remove only)"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Kelp ${VERSION} for Eclipse ${ECLIPSE_VERSION}" \
                   "UninstallString" '"$INSTDIR\uninstall.exe"'
  WriteUninstaller "uninstall.exe"

	; Create Start Menu Shortcuts
  CreateDirectory "$SMPROGRAMS\Kelp ${VERSION} for Eclipse ${ECLIPSE_VERSION}"
  CreateShortCut "$SMPROGRAMS\Kelp ${VERSION} for Eclipse ${ECLIPSE_VERSION}\Uninstall.lnk" \
                 "$INSTDIR\uninstall.exe" "" "$INSTDIR\uninstall.exe" 0

	end:
SectionEnd
;------------------------------------------------------------------------------
;Installer Functions
;------------------------------------------------------------------------------
Function .onInit

# start splash screen
# the plugins dir is automatically deleted when the installer exits
		InitPluginsDir
		File /oname=$PLUGINSDIR\splash.bmp "${NSISDIR}\Modern UI\KelpForEclipse.bmp"
#optional
#File /oname=$PLUGINSDIR\splash.wav "C:\myprog\sound.wav"
		advsplash::show 2000 600 400 -1 $PLUGINSDIR\splash
		Pop $0 ; $0 has '1' if the user closed the splash screen early,
		                ; '0' if everything closed normal, and '-1' if some error occured.
# end splash screen

  ;Extract Install Options INI Files
  !insertmacro MUI_INSTALLOPTIONS_EXTRACT "eclipse.ini"

FunctionEnd
;---------------------------------------------------------------------------------
; Call when installation succeed
;---------------------------------------------------------------------------------
Function .onInstSuccess
FunctionEnd
;------------------------------------------------------------------------------
;Descriptions
;------------------------------------------------------------------------------
!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES
;------------------------------------------------------------------------------
;Uninstaller Section
;------------------------------------------------------------------------------
Section "Uninstall"

  ; remove registry keys
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Kelp ${VERSION} for Eclipse ${ECLIPSE_VERSION}"
  DeleteRegKey HKLM "SOFTWARE\Kelp ${VERSION} for Eclipse ${ECLIPSE_VERSION}"

  ; MUST REMOVE UNINSTALLER, too
  Delete $INSTDIR\uninstall.exe

  ; remove shortcuts, if any.
  Delete "$SMPROGRAMS\Kelp ${VERSION} for Eclipse ${ECLIPSE_VERSION}\*.*"

  ; remove directories used.
  RMDir "$SMPROGRAMS\Kelp ${VERSION} for Eclipse ${ECLIPSE_VERSION}"
  RMDir /r "$INSTDIR\plugins\org.enhydra.kelp.eclipse_${VERSION_PLUGIN}"
	Delete "$INSTDIR\setEasRoot.bat"
	  
SectionEnd
;------------------------------------------------------------------------------
;Uninstaller Functions
;------------------------------------------------------------------------------
Function un.onInit

  ;Get language from registry
  ReadRegStr $LANGUAGE HKCU "Software\${MUI_PRODUCT}" "Installer Language"

FunctionEnd
;------------------------------------------------------------------------------
; GetParent
; input, top of stack  (i.e. C:\Program Files\Poop)
; output, top of stack (replaces, with i.e. C:\Program Files)
; modifies no other variables.
;
; Usage:
;   Push "C:\Program Files\Directory\Whatever"
;   Call GetParent
;   Pop $0
;   ; at this point $0 will equal "C:\Program Files\Directory"
;------------------------------------------------------------------------------
Function GetParent
  Exch $0 ; old $0 is on top of stack
  Push $1
  Push $2
  StrCpy $1 -1
  loop:
    StrCpy $2 $0 1 $1
    StrCmp $2 "" exit
    StrCmp $2 "\" exit
    IntOp $1 $1 - 1
  Goto loop
  exit:
    StrCpy $0 $0 $1
    Pop $2
    Pop $1
    Exch $0 ; put $0 on top of stack, restore $0 to original value
FunctionEnd
;------------------------------------------------------------------------------
; Page to choose java home directory and Enhydra install directory
;------------------------------------------------------------------------------
Function SetCustomPage

  Call CheckEnhydraInstall  ; Check if Enhydra Server installed
	Call IfJavaExist          ; check if JAVA_HOME directory exist

	start:

  !insertmacro MUI_HEADER_TEXT "$(TEXT_IO_TITLE)" "$(TEXT_IO_SUBTITLE)"
  !insertmacro MUI_INSTALLOPTIONS_DISPLAY_RETURN "eclipse.ini"
	Pop $R0
  
   StrCmp $R0 "cancel" end
   StrCmp $R0 "back" end
   StrCmp $R0 "success" 0 error


  !insertmacro MUI_INSTALLOPTIONS_READ ${TEMP1} "eclipse.ini" "Field 2" "State" ;Enhydra Directory
  !insertmacro MUI_INSTALLOPTIONS_READ ${TEMP2} "eclipse.ini" "Field 4" "State" ;JDK Directory
	
	IfFileExists ${TEMP2}\bin\java.exe continue	; check if java.exe exist
	MessageBox MB_OK "File java.exe does not exist in directory ${TEMP2}\bin"
	Goto start
		
	continue:
	IfFileExists ${TEMP2}\bin\javac.exe checkJDK	; check if javac.exe exist
	MessageBox MB_OK "File javac.exe does not exist in directory ${TEMP2}\bin"
	Goto start

	checkJDK:
	IfFileExists ${TEMP2}\jre\lib\jsse.jar checkEnhydra	; check if JDK 1.4.x
	MessageBox MB_OK "File jsse.jar does not exist in directory ${TEMP2}\jre\lib"
	Goto start

	checkEnhydra:
	IfFileExists ${TEMP1}\lib\enhydra.jar end	; check if Enhydra exist
	MessageBox MB_OK "File enhydra.jar does not exist in directory ${TEMP1}\lib"
	Goto start

  error:
    MessageBox MB_OK|MB_ICONSTOP "InstallOptions error:$\r$\n${TEMP1}"

	end:
	Pop $R0
FunctionEnd
;------------------------------------------------------------------------------
; Check if choosed java home directory
;------------------------------------------------------------------------------
Function IfJavaExist

  !insertmacro MUI_INSTALLOPTIONS_WRITE "eclipse.ini" "Settings" "Title" "$(TEXT_IO_PAGECUSTOM_A)"
  !insertmacro MUI_INSTALLOPTIONS_WRITE "eclipse.ini" "Field 1" "Text" "$(TEXT_IO_PAGESUBTITLE_A)"
  !insertmacro MUI_INSTALLOPTIONS_READ ${TEMP2} "eclipse.ini" "Field 4" "State"

	; predict if exist enviroment variable JAVA_HOME
  ReadEnvStr $6 "JAVA_HOME"

  StrCmp $6 "" notsetJAVA_HOME

	IfFileExists $6\bin\javac.exe OK ; check if javac.exe exist
	Goto notsetJAVA_HOME

  notsetJAVA_HOME:
 	ReadRegStr $6 HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\java.exe" "Path"
 	Push $6
  StrCmp $6 "" notregjava
 	Call GetParent
 	Pop $6
  StrCmp $6 "" notregjava
	IfFileExists $6\bin\javac.exe OK	; check if javac.exe exist
	Goto notregjava

	notregjava:
	ReadRegStr $1 HKLM "SOFTWARE\JavaSoft\Java Development Kit" "CurrentVersion"
	ReadRegStr $6 HKLM "SOFTWARE\JavaSoft\Java Development Kit\$1" "JavaHome"
 	Push $6
#  StrCmp $6 "" end
# 	Call GetParent
# 	Pop $6
	IfFileExists $6\bin\javac.exe OK	; check if javac.exe exist
	Goto end

	OK:
  !insertmacro MUI_INSTALLOPTIONS_WRITE "eclipse.ini" "Field 4" "State" "$6"
	
	end:
FunctionEnd
;------------------------------------------------------------------------------
; Call on installation failed
;------------------------------------------------------------------------------
Function .onInstFailed
	Call Cleanup
FunctionEnd
;------------------------------------------------------------------------------
; Call when installation failed 
;------------------------------------------------------------------------------
Function Cleanup
  
  ; remove directories used.
  RMDir /r "$INSTDIR\plugins\org.enhydra.kelp.eclipse_1.0.0"
	Delete "$INSTDIR\setEasRoot.bat"

FunctionEnd
;------------------------------------------------------------------------------
; ReplaceChar
; input, input string  (C:\JBuilder\jdk1.3.1)
;        char to need replaced (\)
;        char to with replaced (/)
; output, top of stack (C:/JBuilder/jdk1.3.1)
; modifies no other variables.
;
; Usage:
;   Push $1 ; "C:\JBuilder\jdk1.3.1"
;   Push "\"
;   Push "/"
;   Call ReplaceChar
;   Pop $0
;   ; at this point $0 will equal "C:/JBuilder/jdk1.3.1"
;------------------------------------------------------------------------------
Function ReplaceChar
					; stack="/","\","C:\JBuilder\jdk1.3.1", ... (from top to down)
  Exch $2 ; $2="/", stack="2-gi param","\","C:\JBuilder\jdk1.3.1", ...
  Exch  	; stack="\","2-ti param","C:\JBuilder\jdk1.3.1", ...
  Exch $1 ; $1="\", stack="1-vi param","2-gi param","C:\JBuilder\jdk1.3.1", ...
  Exch    ; stack="2-gi param","1-vi param","C:\JBuilder\jdk1.3.1", ...
	Exch 2	; stack="C:\JBuilder\jdk1.3.1","1-vi param","2-gi param", ...
  Exch $0 ; $0="C:\JBuilder\jdk1.3.1", stack="0-ti param","1-vi param","2-gi param", ...
  Exch 2  ; stack="2-gi param","1-vi param","0-ti param", ...

  Push $3	; Len("C:\JBuilder\jdk1.3.1")
  Push $4	; index of string
  Push $5 ; tmp - form strat to found char witch need to change
  Push $6 ; tmp - from found char witch need to change + 1 to end ($3)
  Push $7 ; tmp - position where found char witch need to change + 1
  StrLen $3 $0
  StrCpy $4 1
  loop:
    StrCpy $5 $0 1 $4
    StrCmp $5 "" exit
    StrCmp $5 $1 change
    IntOp $4 $4 + 1
  Goto loop
  change:
  	StrCpy $6 $4				; pozition where found char witch need to change
  	StrCpy $5 $0 $6   	; $5="C:"
  	StrCpy $5 "$5$2"   	; $5="C:/"
  	StrCpy $7 $4				; pozition where found char witch need to change
  	IntOp $7 $7 + 1 		; next pozition
  	StrCpy $6 $0 $3 $7  ; $6="JBuilder\jdk1.3.1"
  	StrCpy $0 $5				; $0="C:/"
  	StrCpy $0 "$0$6" 		; $0="C:/JBuilder\jdk1.3.1"
  Goto loop
  exit:
    Pop $7
    Pop $6
    Pop $5
    Pop $4
    Pop $3
    Pop $2
    Pop $1
    Exch $0 ; put $0 on top of stack, restore $0 to original value
FunctionEnd
;--------------------------------------------------------------------------
; Check if Enhydra Server installation exist
;--------------------------------------------------------------------------
Function CheckEnhydraInstall
  
  ReadRegStr $R0 HKLM "SOFTWARE\Enhydra${VERSION}" "Install_Dir" 
  StrCmp $R0 "" end
  ; set installation directory to <ENHYDRA_ROOT>\Director
  !insertmacro MUI_INSTALLOPTIONS_WRITE "eclipse.ini" "Field 2" "State" $R0 
  
  end:
FunctionEnd
