;------------------------------------------------------------------------------
; Kelp 5.1 for JBuilder 9 installation script
;	All output message will be written to file ..\..\..\..\jbuilder9.log
;------------------------------------------------------------------------------
#!define VERSION "5.1" ;Define your own software name here
#!define RELEASE "1" ; need for building with makensisw.exe
;--------------------------------
;Version Information
  VIProductVersion "5.1.0.0"
;--------------------------------
!define MUI_PRODUCT "Kelp ${VERSION} for JBuilder 9" ;Define your own software name here
!define MUI_VERSION "${VERSION}" ;Define your own software version here
!define MUI_NAME "${MUI_PRODUCT}"

!define MUI_ICON "${NSISDIR}\Contrib\Icons\enhydra1-install.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Icons\enhydra1-uninstall.ico"

# defines SF_*, SECTION_OFF and some macros
!include Sections.nsh

!define MUI_UNTEXT_INTRO_TITLE "Uninstall ${MUI_PRODUCT}"
!define MUI_UNTEXT_INTRO_SUBTITLE "Remove ${MUI_PRODUCT} from your computer."

!include "MUI.nsh"
;------------------------------------------------------------------------------
;Configuration
;------------------------------------------------------------------------------
  !define MUI_WELCOMEPAGE
  !define MUI_LICENSEPAGE
  !define MUI_DIRECTORYPAGE
  
  !define MUI_ABORTWARNING

  !define MUI_CUSTOMPAGECOMMANDS
  
  !define MUI_UNINSTALLER
  !define MUI_UNCONFIRMPAGE

  !define TEMP1 $R0
  !define TEMP2 $R1
    
# Language
  !define MUI_BRANDINGTEXT "Kelp Windows Installation "
  !insertmacro MUI_LANGUAGE "English"

# General
	OutFile "..\..\..\..\distribution\kelp-jbuilder9-${VERSION}-${RELEASE}.setup.exe"	; The file to write

# Install Options pages
# LANG_ENGLISH
# Header
    LangString TEXT_IO_TITLE ${LANG_ENGLISH} "Please select the appropriate directories"
    LangString TEXT_IO_SUBTITLE ${LANG_ENGLISH} "Click button on right side to set the appropriate directories :"
# Window titles
    LangString TEXT_IO_PAGESUBTITLE_A ${LANG_ENGLISH} "Select Enhydra directory :"
    LangString TEXT_IO_PAGECUSTOM_A ${LANG_ENGLISH} "${MUI_PRODUCT} Setup"
    LangString TEXT_IO_PAGETITLE_A ${LANG_ENGLISH} ""

# Page order 
	!insertmacro MUI_PAGE_WELCOME
	!insertmacro MUI_PAGE_LICENSE
  Page custom SetCustomPage "" "$(TEXT_IO_PAGETITLE_A)"
  !insertmacro MUI_PAGE_DIRECTORY
  !insertmacro MUI_PAGE_INSTFILES
  
# License page
  LicenseData /LANG=${LANG_ENGLISH} "${NSISDIR}\Contrib\License\LicenseEnglish.txt"

# Component-selection page
    ;Titles
    LangString TITLE_SecCopyUI ${LANG_ENGLISH} "Kelp"

# Descriptions
    LangString DESC_SecCopyUI ${LANG_ENGLISH} "Install Kelp ${VERSION} to the application folder."

# Folder-selection page
  InstallDir "C:\"
  
# Things that need to be extracted on startup (keep these lines before any File command!)
# Only useful for BZIP2 compression
# Use ReserveFile for your own Install Options ini files too!
  !insertmacro MUI_RESERVEFILE_INSTALLOPTIONS
  ReserveFile "jbuilder9.ini"
;------------------------------------------------------------------------------
;Modern UI System
;------------------------------------------------------------------------------
;------------------------------------------------------------------------------
;Installer Sections
;------------------------------------------------------------------------------
Section $(TITLE_SecCopyUI) SecCopyUI

  ; Set output path to the installation directory.
  StrCpy $1 $INSTDIR
;  StrCpy $INSTDIR "$INSTDIR\Kelp"
;  StrCpy $OUTDIR "$INSTDIR\Kelp"
  StrCpy $OUTDIR "$INSTDIR"
  SetOutPath $INSTDIR

  File /r "..\..\JBuilder9\*.*"
	  
  !insertmacro MUI_INSTALLOPTIONS_READ $2 "jbuilder9.ini" "Field 2" "State" ;Enhydra Directory
  !insertmacro MUI_INSTALLOPTIONS_READ $3 "jbuilder9.ini" "Field 4" "State" ;JDK Directory

  ; replace char '\' with char '/' at Enhydra Directory
  Push "$2"
  Push "\"
  Push "/"
	Call ReplaceChar
	Pop $2
  ; replace char '\' with char '/' at JDK Directory
  Push "$3"
  Push "\"
  Push "/"
	Call ReplaceChar
	Pop $3

  FileOpen $8 $INSTDIR\kelp\setEasRoot.bat w
  FileWrite $8 "@echo off$\r$\n"
  FileWrite $8 "set JAVA=$3\bin\java.exe$\r$\n"
  FileWrite $8 "set ENHYDRA_ROOT=$2$\r$\n"
  FileWrite $8 "set LIB_ROOT=$1/lib/$\r$\n"
  FileWrite $8 "$\r$\n"
  FileWrite $8 "%JAVA% -cp %CLASSPATH%;%LIB_ROOT%/toolbox.jar org.enhydra.tool.InitEnhydraRoot %ENHYDRA_ROOT%$\r$\n"
  FileClose $8

  ClearErrors
#  ExecWait '$INSTDIR\kelp\setEasRoot.bat' $0	; start configuring Kelp
	nsExec::ExecToLog '$INSTDIR\kelp\setEasRoot.bat'
	Pop $0                                                ; return value/error/timeout
	Pop $1                                                ; return value/error/timeout
  StrCmp $0 "0" setLib

  DetailPrint "Kelp ${VERSION} failed (output: $0)"
  Call Cleanup
  Goto end
setLib:
  Call SetEnhydraLibrary
  Call JBuilderConfig
  StrCmp $0 "0" success
	DetailPrint "Kelp ${VERSION} failed (output: $0)"
	Call Cleanup
	Goto end

	success:
	DetailPrint "Kelp ${VERSION} succeded (output: $0)"

  ; Write the installation path into the registry
  WriteRegStr HKLM "SOFTWARE\Kelp ${VERSION} for JBuilder 9" "Install_Dir" "$INSTDIR"

  ; Write the uninstall keys for Windows
  WriteRegStr HKLM \
               "Software\Microsoft\Windows\CurrentVersion\Uninstall\Kelp ${VERSION} for JBuilder 9" \
              "DisplayName" \
              "Kelp ${VERSION} for JBuilder 9 (remove only)"
  WriteRegStr HKLM \
              "Software\Microsoft\Windows\CurrentVersion\Uninstall\Kelp ${VERSION} for JBuilder 9" \
              "UninstallString" \
              '"$INSTDIR\kelp\uninstall.exe"'
  WriteRegStr HKLM \
              "Software\Microsoft\Windows\CurrentVersion\Uninstall\Kelp ${VERSION} for JBuilder 9" \
              "EnhydraInstallDir" \
              '$2'
  WriteUninstaller "kelp\uninstall.exe"

	; Create Start Menu Shortcuts
  CreateDirectory "$SMPROGRAMS\Kelp ${VERSION} for JBuilder 9"
  CreateShortCut "$SMPROGRAMS\Kelp ${VERSION} for JBuilder 9\Uninstall.lnk"\
                 "$INSTDIR\kelp\uninstall.exe"\
                 ""\
                 "$INSTDIR\kelp\uninstall.exe"\
                 0
	; Create Shortcuts for Tutorial file  							 
  CreateShortCut "$SMPROGRAMS\Kelp ${VERSION} for JBuilder 9\Quick start.lnk" \
                 "$INSTDIR\kelp\doc\kelp_jbuilder8.html" \
                 "" \
                 "$INSTDIR\kelp\doc\jbuilder8-install.ico" 0
	
	end:
SectionEnd
;------------------------------------------------------------------------------
;Installer Functions
;------------------------------------------------------------------------------
Function .onInit

# start splash screen
# the plugins dir is automatically deleted when the installer exits
		InitPluginsDir
		File /oname=$PLUGINSDIR\splash.bmp "${NSISDIR}\Modern UI\KelpForJBuilder9.bmp"
#optional
#File /oname=$PLUGINSDIR\splash.wav "C:\myprog\sound.wav"
		advsplash::show 1000 600 400 -1 $PLUGINSDIR\splash
		Pop $0 ; $0 has '1' if the user closed the splash screen early,
		                ; '0' if everything closed normal, and '-1' if some error occured.
# end splash screen

  ;Extract Install Options INI Files
  !insertmacro MUI_INSTALLOPTIONS_EXTRACT "jbuilder9.ini"

  ReadRegStr $R0 HKLM "SOFTWARE\Borland\JBuilder\9.0" "PathName" 
  StrCmp $R0 "" end
  StrCpy $INSTDIR $R0
  
  end:  

FunctionEnd
;---------------------------------------------------------------------------------
; Call when installation succeed
;---------------------------------------------------------------------------------
Function .onInstSuccess
FunctionEnd
;------------------------------------------------------------------------------
;Descriptions
;------------------------------------------------------------------------------
!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES
;------------------------------------------------------------------------------
;Uninstaller Section
;------------------------------------------------------------------------------
Section "Uninstall"

	; remove addjars from jbuilder.config file
  Call un.JBuilderConfig

  ; remove registry keys
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Kelp ${VERSION} for JBuilder 9"
  DeleteRegKey HKLM "SOFTWARE\Kelp ${VERSION} for JBuilder 9"

  ; MUST REMOVE UNINSTALLER, too
  Delete $INSTDIR\kelp\uninstall.exe

  ; remove shortcuts, if any.
  Delete "$SMPROGRAMS\Kelp ${VERSION} for JBuilder 9\*.*"

  ; remove directories used.
  RMDir "$SMPROGRAMS\Kelp ${VERSION} for JBuilder 9"
  RMDir /r "$INSTDIR\Kelp"
  Delete "$INSTDIR\lib\KelpAntCore.jar"
  Delete "$INSTDIR\lib\toolbox.jar"
  Delete "$INSTDIR\lib\ext\kelp.jar"
  Delete "$INSTDIR\lib\Enhydra.library"
  
SectionEnd
;------------------------------------------------------------------------------
;Uninstaller Functions
;------------------------------------------------------------------------------
Function un.onInit

  ;Get language from registry
  ReadRegStr $LANGUAGE HKCU "Software\${MUI_PRODUCT}" "Installer Language"
  StrCpy $INSTDIR $INSTDIR -5

FunctionEnd
;------------------------------------------------------------------------------
; GetParent
; input, top of stack  (i.e. C:\Program Files\Poop)
; output, top of stack (replaces, with i.e. C:\Program Files)
; modifies no other variables.
;
; Usage:
;   Push "C:\Program Files\Directory\Whatever"
;   Call GetParent
;   Pop $0
;   ; at this point $0 will equal "C:\Program Files\Directory"
;------------------------------------------------------------------------------
Function GetParent
  Exch $0 ; old $0 is on top of stack
  Push $1
  Push $2
  StrCpy $1 -1
  loop:
    StrCpy $2 $0 1 $1
    StrCmp $2 "" exit
    StrCmp $2 "\" exit
    IntOp $1 $1 - 1
  Goto loop
  exit:
    StrCpy $0 $0 $1
    Pop $2
    Pop $1
    Exch $0 ; put $0 on top of stack, restore $0 to original value
FunctionEnd
;------------------------------------------------------------------------------
; Page to choose java home directory and Enhydra install directory
;------------------------------------------------------------------------------
Function SetCustomPage

  Call CheckEnhydraInstall  ; check if installation of Enhydra 5.1 exist
	Call IfJavaExist          ; check if JAVA_HOME directory exist

	start:

  !insertmacro MUI_HEADER_TEXT "$(TEXT_IO_TITLE)" "$(TEXT_IO_SUBTITLE)"
  !insertmacro MUI_INSTALLOPTIONS_DISPLAY_RETURN "jbuilder9.ini"
	Pop $R0
  
   StrCmp $R0 "cancel" end
   StrCmp $R0 "back" end
   StrCmp $R0 "success" 0 error


  !insertmacro MUI_INSTALLOPTIONS_READ ${TEMP1} "jbuilder9.ini" "Field 2" "State" ;Enhydra Directory
  !insertmacro MUI_INSTALLOPTIONS_READ ${TEMP2} "jbuilder9.ini" "Field 4" "State" ;JDK Directory

	IfFileExists ${TEMP2}\bin\java.exe continue	; check if java.exe exist
	MessageBox MB_OK "File java.exe does not exist in directory ${TEMP2}\bin"
	Goto start
		
	continue:
	IfFileExists ${TEMP2}\bin\javac.exe checkJDK	; check if javac.exe exist
	MessageBox MB_OK "File javac.exe does not exist in directory ${TEMP2}\bin"
	Goto start

	checkJDK:
	IfFileExists ${TEMP2}\jre\lib\jsse.jar checkEnhydra	; check if JDK 1.4.x
	MessageBox MB_OK "File jsse.jar does not exist in directory ${TEMP2}\jre\lib"
	Goto start

	checkEnhydra:
	IfFileExists ${TEMP1}\lib\enhydra.jar end	; check if Enhydra exist
	MessageBox MB_OK "File enhydra.jar does not exist in directory ${TEMP1}\lib"
	Goto start

  error:
    MessageBox MB_OK|MB_ICONSTOP "InstallOptions error:$\r$\n${TEMP1}"

	end:
	Pop $R0
FunctionEnd
;------------------------------------------------------------------------------
; Check if choosed java home directory
;------------------------------------------------------------------------------
Function IfJavaExist

  !insertmacro MUI_INSTALLOPTIONS_WRITE "jbuilder9.ini" "Settings" "Title" "$(TEXT_IO_PAGECUSTOM_A)"
  !insertmacro MUI_INSTALLOPTIONS_WRITE "jbuilder9.ini" "Field 1" "Text" "$(TEXT_IO_PAGESUBTITLE_A)"
  !insertmacro MUI_INSTALLOPTIONS_READ ${TEMP2} "jbuilder9.ini" "Field 4" "State"

  StrCmp ${TEMP2} "" end
  
	; predict if exist enviroment variable JAVA_HOME
  ReadEnvStr $6 "JAVA_HOME"

  StrCmp $6 "" notsetJAVA_HOME

	IfFileExists $6\bin\javac.exe OK ; check if javac.exe exist
	Goto notsetJAVA_HOME

  notsetJAVA_HOME:
 	ReadRegStr $6 HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\java.exe" "Path"
 	Push $6
  StrCmp $6 "" notregjava
 	Call GetParent
 	Pop $6
  StrCmp $6 "" notregjava
	IfFileExists $6\bin\javac.exe OK	; check if javac.exe exist
	Goto notregjava

	notregjava:
	ReadRegStr $1 HKLM "SOFTWARE\JavaSoft\Java Development Kit" "CurrentVersion"
	ReadRegStr $6 HKLM "SOFTWARE\JavaSoft\Java Development Kit\$1" "JavaHome"
 	Push $6
#  StrCmp $6 "" end
# 	Call GetParent
# 	Pop $6
	IfFileExists $6\bin\javac.exe OK	; check if javac.exe exist
	Goto end

	OK:
  !insertmacro MUI_INSTALLOPTIONS_WRITE "jbuilder9.ini" "Field 4" "State" "$6"
	
	end:
FunctionEnd
;------------------------------------------------------------------------------
; Call on installation failed
;------------------------------------------------------------------------------
Function .onInstFailed
	Call Cleanup
FunctionEnd
;------------------------------------------------------------------------------
; Call when installation failed 
;------------------------------------------------------------------------------
Function Cleanup
  ; remove registry keys
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Kelp ${VERSION} for JBuilder 9"
  DeleteRegKey HKLM "SOFTWARE\Kelp ${VERSION} for JBuilder 9"

  ; MUST REMOVE UNINSTALLER, too
  Delete $INSTDIR\kelp\uninstall.exe

  ; remove shortcuts, if any.
  Delete "$SMPROGRAMS\Kelp ${VERSION} for JBuilder 9\*.*"

  ; remove directories used.
  RMDir "$SMPROGRAMS\Kelp ${VERSION} for JBuilder 9"
  RMDir /r "$INSTDIR"

FunctionEnd

function StrReplace
  Exch $0 ;this will replace wrong characters
  Exch
  Exch $1 ;needs to be replaced
  Exch
  Exch 2
  Exch $2 ;the orginal string
  Push $3 ;counter
  Push $4 ;temp character
  Push $5 ;temp string
  Push $6 ;length of string that need to be replaced
  Push $7 ;length of string that will replace
  Push $R0 ;tempstring
  Push $R1 ;tempstring
  Push $R2 ;tempstring
  StrCpy $3 "-1"
  StrCpy $5 ""
  StrLen $6 $1
  StrLen $7 $0
  Loop:
  IntOp $3 $3 + 1
  StrCpy $4 $2 $6 $3
  StrCmp $4 "" ExitLoop
  StrCmp $4 $1 Replace
  Goto Loop
  Replace:
  StrCpy $R0 $2 $3
  IntOp $R2 $3 + $6
  StrCpy $R1 $2 "" $R2
  StrCpy $2 $R0$0$R1
  IntOp $3 $3 + $7
  Goto Loop
  ExitLoop:
  StrCpy $0 $2
  Pop $R2
  Pop $R1
  Pop $R0
  Pop $7
  Pop $6
  Pop $5
  Pop $4
  Pop $3
  Pop $2
  Pop $1
  Exch $0
FunctionEnd

Function SetEnhydraLibrary

#  $1 $INSTDIR
#  $2 Enhydra Directory
#  $3 JDK Directory

ClearErrors

FileOpen $9 "$INSTDIR\lib\Enhydra.library.in" "r"
GetTempFileName $R0
FileOpen $8 $R0 "w"
StrCpy $7 -1	; default value (string addjars is not found)

loop:
   FileRead $9 $6
   IfErrors done

   Push $6
   Push "@ENHYDRA_HOME@" ;needs to be replaced
   Push $2 ;will replace wrong characters
   Call StrReplace
   Push "@JAVA_HOME@" ;needs to be replaced
   Push $3 ;will replace wrong characters
   Call StrReplace
   Pop $0 ; replaced string

   FileWrite $8 $0
   Goto loop

done:
   FileClose $9
   FileClose $8
   CopyFiles /SILENT $R0 "$INSTDIR\lib\Enhydra.library"
   Delete "$INSTDIR\lib\Enhydra.library.in"
   StrCpy $0 0	; set OK

FunctionEnd

Function JBuilderConfig

#  $1 $INSTDIR
#  $2 Enhydra Directory
#  $3 JDK Directory

ClearErrors
IfFileExists "$INSTDIR\bin\jbuilder.config.save" 0 start
Delete "$INSTDIR\bin\jbuilder.config.save"
start:
FileOpen $9 "$INSTDIR\bin\jbuilder.config" "r"
GetTempFileName $R0
FileOpen $8 $R0 "w"
StrCpy $7 -1	; default value (string addjars is not found)

loop:
   FileRead $9 $6
   IfErrors done
   
   Push $6
   Push "addjars"
   Call StrStr ; Find "addjars" in $6
   Pop $0 ; pos of our dir
   IntCmp $0 -1 notfound
    
	 StrCpy $7 0	; string addjars is found	in current line
   Goto writeTempFile

notfound:
   StrCmp $7 0 addclasspath
   
writeTempFile:   
   FileWrite $8 $6
   Goto loop

addclasspath:
   FileWrite $8 "addjars $2/lib$\r$\n"
   FileWrite $8 "addjars $2/dods/lib$\r$\n"
   FileWrite $8 "addjars $2/lib/dom$\r$\n"
   FileWrite $8 "$\r$\n"
	 StrCpy $7 -1	; default value (string addjars is not found)
   Goto loop

done:
   FileClose $9
   FileClose $8
   Rename "$INSTDIR\bin\jbuilder.config" "$INSTDIR\bin\jbuilder.config.save"
   CopyFiles /SILENT $R0 "$INSTDIR\bin\jbuilder.config"
   Delete $R0
   StrCpy $0 0	; set OK

FunctionEnd   
;====================================================
; StrStr - Finds a given string in another given string.
;               Returns -1 if not found and the pos if found.
;          Input: head of the stack - string to find
;                      second in the stack - string to find in
;          Output: head of the stack
;====================================================
Function StrStr
  Push $0
  Exch
  Pop $0 ; $0 now have the string to find
  Push $1
  Exch 2
  Pop $1 ; $1 now have the string to find in
  Exch
  Push $2
  Push $3
  Push $4
  Push $5

  StrCpy $2 -1
  StrLen $3 $0
  StrLen $4 $1
  IntOp $4 $4 - $3

  StrStr_loop:
    IntOp $2 $2 + 1
    IntCmp $2 $4 0 0 StrStrReturn_notFound
    StrCpy $5 $1 $3 $2
    StrCmp $5 $0 StrStr_done StrStr_loop

  StrStrReturn_notFound:
    StrCpy $2 -1

  StrStr_done:
    Pop $5
    Pop $4
    Pop $3
    Exch $2
    Exch 2
    Pop $0
    Pop $1
FunctionEnd
;------------------------------------------------------------------------
Function un.JBuilderConfig

ClearErrors

# $2 - Enhydra Install Directory
ReadRegStr $2 HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Kelp ${VERSION} for JBuilder 9" "EnhydraInstallDir"

FileOpen $9 "$INSTDIR\bin\jbuilder.config" "r"
GetTempFileName $R0
FileOpen $8 $R0 "w"

StrCpy $7 "addjars $2/lib"
StrCpy $5 "addjars $2/dods/lib"

# 	 MessageBox MB_OK "$$7=$7"
# 	 MessageBox MB_OK "$$5=$5"

loop:
   FileRead $9 $6
   IfErrors done

# 	 MessageBox MB_OK "linija iz fajla=$6"
	
   Push $6 ;line from file
   Push $7 ; string to find
   Call un.StrStr ; Find $7 in $6
   Pop $0 ; pos of our dir
#   MessageBox MB_OK "first-vratio=$0"

#   IntCmp val1 val2 jump_if_equal [jump_if_val1_less] [jump_if_val1_more]

   IntCmp $0 -1 secondline 
#   MessageBox MB_OK "first-pronasao"
	 Goto loop	

secondline:

# 	 MessageBox MB_OK "secondline"

   Push $6
   Push $5
   Call un.StrStr ; Find "addjars $2/dods/lib" in $6
   Pop $0 ; pos of our dir
#   MessageBox MB_OK "second-vratio=$0"
   IntCmp $0 -1 writeTempFile
#   MessageBox MB_OK "second-pronasao"
	 Goto loop	
   
writeTempFile:   
#   MessageBox MB_OK "writeTempFile"
   FileWrite $8 $6
   Goto loop

done:
   FileClose $9
   FileClose $8
   IfFileExists "$INSTDIR\bin\jbuilder.config.save" 0 continue
	 Delete	"$INSTDIR\bin\jbuilder.config.save"

continue:  
   Rename "$INSTDIR\bin\jbuilder.config" "$INSTDIR\bin\jbuilder.config.save"
   CopyFiles /SILENT $R0 "$INSTDIR\bin\jbuilder.config"
   Delete $R0
   StrCpy $0 0	; set OK
   Goto end
   
end:

FunctionEnd   
;====================================================
; StrStr - Finds a given string in another given string.
;               Returns -1 if not found and the pos if found.
;          Input: head of the stack - string to find
;                      second in the stack - string to find in
;          Output: head of the stack
;====================================================
Function un.StrStr
  Push $0
  Exch
  Pop $0 ; $0 now have the string to find
  Push $1
  Exch 2
  Pop $1 ; $1 now have the string to find in
  Exch
  Push $2
  Push $3
  Push $4
  Push $5

#   MessageBox MB_OK "$0-now have the string to find"
#   MessageBox MB_OK "$1-now have the string to find in"
   
  StrCpy $2 -1
  StrLen $3 $0
  StrLen $4 $1
  IntOp $4 $4 - $3

  StrStr_loop:
    IntOp $2 $2 + 1
    IntCmp $2 $4 0 0 StrStrReturn_notFound
    StrCpy $5 $1 $3 $2
    StrCmp $5 $0 StrStr_done StrStr_loop

  StrStrReturn_notFound:
    StrCpy $2 -1

  StrStr_done:
    Pop $5
    Pop $4
    Pop $3
    Exch $2
    Exch 2
    Pop $0
    Pop $1
FunctionEnd
;------------------------------------------------------------------------------
; ReplaceChar
; input, input string  (C:\JBuilder\jdk1.3.1)
;        char to need replaced (\)
;        char to with replaced (/)
; output, top of stack (C:/JBuilder/jdk1.3.1)
; modifies no other variables.
;
; Usage:
;   Push $1 ; "C:\JBuilder\jdk1.3.1"
;   Push "\"
;   Push "/"
;   Call ReplaceChar
;   Pop $0
;   ; at this point $0 will equal "C:/JBuilder/jdk1.3.1"
;------------------------------------------------------------------------------
Function ReplaceChar
					; stack="/","\","C:\JBuilder\jdk1.3.1", ... (from top to down)
  Exch $2 ; $2="/", stack="2-gi param","\","C:\JBuilder\jdk1.3.1", ...
  Exch  	; stack="\","2-ti param","C:\JBuilder\jdk1.3.1", ...
  Exch $1 ; $1="\", stack="1-vi param","2-gi param","C:\JBuilder\jdk1.3.1", ...
  Exch    ; stack="2-gi param","1-vi param","C:\JBuilder\jdk1.3.1", ...
	Exch 2	; stack="C:\JBuilder\jdk1.3.1","1-vi param","2-gi param", ...
  Exch $0 ; $0="C:\JBuilder\jdk1.3.1", stack="0-ti param","1-vi param","2-gi param", ...
  Exch 2  ; stack="2-gi param","1-vi param","0-ti param", ...

  Push $3	; Len("C:\JBuilder\jdk1.3.1")
  Push $4	; index of string
  Push $5 ; tmp - form strat to found char witch need to change
  Push $6 ; tmp - from found char witch need to change + 1 to end ($3)
  Push $7 ; tmp - position where found char witch need to change + 1
  StrLen $3 $0
  StrCpy $4 1
  loop:
    StrCpy $5 $0 1 $4
    StrCmp $5 "" exit
    StrCmp $5 $1 change
    IntOp $4 $4 + 1
  Goto loop
  change:
  	StrCpy $6 $4				; pozition where found char witch need to change
  	StrCpy $5 $0 $6   	; $5="C:"
  	StrCpy $5 "$5$2"   	; $5="C:/"
  	StrCpy $7 $4				; pozition where found char witch need to change
  	IntOp $7 $7 + 1 		; next pozition
  	StrCpy $6 $0 $3 $7  ; $6="JBuilder\jdk1.3.1"
  	StrCpy $0 $5				; $0="C:/"
  	StrCpy $0 "$0$6" 		; $0="C:/JBuilder\jdk1.3.1"
  Goto loop
  exit:
    Pop $7
    Pop $6
    Pop $5
    Pop $4
    Pop $3
    Pop $2
    Pop $1
    Exch $0 ; put $0 on top of stack, restore $0 to original value
FunctionEnd
;--------------------------------------------------------------------------
; Check if Enhydra Server installation exist
;--------------------------------------------------------------------------
Function CheckEnhydraInstall
  
  ReadRegStr $R0 HKLM "SOFTWARE\Enhydra${VERSION}" "Install_Dir" 
  StrCmp $R0 "" end
  ; set installation directory to <ENHYDRA_ROOT>\Director
  !insertmacro MUI_INSTALLOPTIONS_WRITE "jbuilder9.ini" "Field 2" "State" $R0 
  
  end:
FunctionEnd
