;------------------------------------------------------------------------------
; Kelp 5.1 installation script for JDeveloper 
;	All output message will be written to file ..\..\..\..\jdeveloper.log
;------------------------------------------------------------------------------
#!define VERSION "5.1" ;Define your own software name here
#!define RELEASE "1" ; need for building with makensisw.exe
;--------------------------------
;Version Information
  VIProductVersion "5.1.0.0"
;--------------------------------
!define MUI_PRODUCT "Kelp ${VERSION} for JDeveloper" ;Define your own software name here
!define MUI_VERSION "${VERSION}" ;Define your own software version here
!define MUI_NAME "${MUI_PRODUCT}"

!define MUI_ICON "${NSISDIR}\Contrib\Icons\enhydra1-install.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Icons\enhydra1-uninstall.ico"

# defines SF_*, SECTION_OFF and some macros
!include Sections.nsh

!define MUI_UNTEXT_INTRO_TITLE "Uninstall ${MUI_PRODUCT}"
!define MUI_UNTEXT_INTRO_SUBTITLE "Remove ${MUI_PRODUCT} from your computer."

!include "MUI.nsh"
;------------------------------------------------------------------------------
;Configuration
;------------------------------------------------------------------------------
  !define MUI_WELCOMEPAGE
  !define MUI_LICENSEPAGE
  !define MUI_DIRECTORYPAGE
  
  !define MUI_ABORTWARNING

  !define MUI_CUSTOMPAGECOMMANDS
  
  !define MUI_UNINSTALLER
  !define MUI_UNCONFIRMPAGE

  !define TEMP1 $R0
  !define TEMP2 $R1
    
# Language
  !define MUI_BRANDINGTEXT "Kelp Windows Installation "
  !insertmacro MUI_LANGUAGE "English"

# General
	OutFile "..\..\..\..\distribution\kelp-jdeveloper-${VERSION}-${RELEASE}.setup.exe"	; The file to write

# Install Options pages
# LANG_ENGLISH
# Header
    LangString TEXT_IO_TITLE ${LANG_ENGLISH} "Please select the appropriate directories"
    LangString TEXT_IO_SUBTITLE ${LANG_ENGLISH} "Click button on right side to set the appropriate directories :"
# Window titles
    LangString TEXT_IO_PAGESUBTITLE_A ${LANG_ENGLISH} "Select Enhydra directory :"
    LangString TEXT_IO_PAGECUSTOM_A ${LANG_ENGLISH} "${MUI_PRODUCT} Setup"
    LangString TEXT_IO_PAGETITLE_A ${LANG_ENGLISH} ""
# Window titles
    LangString TEXT_IO_TITLE_JDK ${LANG_ENGLISH} "Upgrade the JDK definition to JDK 1.4.x"
    LangString TEXT_IO_PAGESUBTITLE_A_JDK ${LANG_ENGLISH} "Important notice!!!"
    LangString TEXT_IO_PAGESUBTITLE_B_JDK ${LANG_ENGLISH} "For using Kelp with JDeveloper you must upgrade the JDK definition to JDK 1.4.x so if you don't upgrade the shared JDK definition to JDK 1.4.x Kelp, only the part of it will work. You must do this manualy or select check box bellow and installation will do this for you. IF YOU HAVE ALREADY DONE THIS, DON'T SELECT CHECK BOX BELLOW."
    LangString TEXT_IO_PAGETITLE_A_JDK ${LANG_ENGLISH} ""
    LangString TEXT_IO_TITLE_A_JDK ${LANG_ENGLISH} "${MUI_PRODUCT} Setup"
    LangString TEXT_IO_CANCEL_A_JDK ${LANG_ENGLISH} "&Cancel"
    LangString TEXT_IO_NEXT_A_JDK ${LANG_ENGLISH} "&Next >"
    LangString TEXT_IO_BACK_A_JDK ${LANG_ENGLISH} "< &Back"

# Page order 
	!insertmacro MUI_PAGE_WELCOME
	!insertmacro MUI_PAGE_LICENSE
  Page custom SetCustomPageJDK "" "$(TEXT_IO_PAGETITLE_A_JDK)" ; set using JDK 1.4.x with NetBeans IDE
  Page custom SetCustomPage "" "$(TEXT_IO_PAGETITLE_A)"
  !insertmacro MUI_PAGE_DIRECTORY
  !insertmacro MUI_PAGE_INSTFILES
  
# License page
  LicenseData /LANG=${LANG_ENGLISH} "${NSISDIR}\Contrib\License\LicenseEnglish.txt"

# Component-selection page
    ;Titles
    LangString TITLE_SecCopyUI ${LANG_ENGLISH} "Kelp"

# Descriptions
    LangString DESC_SecCopyUI ${LANG_ENGLISH} "Install Kelp ${VERSION} to the application folder."

# Folder-selection page
  InstallDir "C:\"
  
# Things that need to be extracted on startup (keep these lines before any File command!)
# Only useful for BZIP2 compression
# Use ReserveFile for your own Install Options ini files too!
  !insertmacro MUI_RESERVEFILE_INSTALLOPTIONS
  ReserveFile "jdeveloper.ini"
  ReserveFile "jdk14x.ini"
;------------------------------------------------------------------------------
;Modern UI System
;------------------------------------------------------------------------------
;------------------------------------------------------------------------------
;Installer Sections
;------------------------------------------------------------------------------
Section $(TITLE_SecCopyUI) SecCopyUI

  ; Set output path to the installation directory.
  StrCpy $R5 $INSTDIR
  StrCpy $OUTDIR "$INSTDIR"
  SetOutPath $INSTDIR

  File /r "..\..\JDeveloper\*.*"
	
  !insertmacro MUI_INSTALLOPTIONS_READ $2 "jdeveloper.ini" "Field 2" "State" ;Enhydra Directory
  !insertmacro MUI_INSTALLOPTIONS_READ $3 "jdeveloper.ini" "Field 4" "State" ;JDK Directory
  !insertmacro MUI_INSTALLOPTIONS_READ $9 "jdk14x.ini" "Field 3" "state" 
  StrCmp $9 "0" continue
  Call UpgradeJDKConfig

  continue:
	StrCpy $1 $R5
    ; replace char '\' with char '/' at installation directory string
    Push "$1"
    Push "\"
    Push "/"
    Call ReplaceChar
    Pop $1
	
    ; replace char '\' with char '/' at Enhydra Directory string
    Push "$2"
    Push "\"
    Push "/"
    Call ReplaceChar
    Pop $2

	FileOpen $8 $INSTDIR\jdev\kelp\setEasRoot.bat w
	FileWrite $8 "@echo off$\r$\n"
	FileWrite $8 "set JAVA=$3\bin\java.exe$\r$\n"
	FileWrite $8 "set ENHYDRA_ROOT=$2$\r$\n"
	FileWrite $8 "set EXTENSION_ROOT=$1/jdev/lib/ext/kelpLib$\r$\n"
	FileWrite $8 "$\r$\n"
	FileWrite $8 "%JAVA% -cp %CLASSPATH%;%EXTENSION_ROOT%/toolbox.jar org.enhydra.tool.InitEnhydraRoot %ENHYDRA_ROOT%$\r$\n"
	FileClose $8

  ClearErrors
#  ExecWait '$INSTDIR\jdev\kelp\setEasRoot.bat' $0	; start configuring Kelp
	nsExec::ExecToLog '$INSTDIR\jdev\kelp\setEasRoot.bat'
	Pop $0                                                ; return value/error/timeout
	Pop $1                                                ; return value/error/timeout
  StrCmp $0 "0" success

	DetailPrint "Kelp ${VERSION} failed (output: $0)"
	Call Cleanup
	Goto end

	success:
	DetailPrint "Kelp ${VERSION} succeded (output: $0)"

  ; Write the installation path into the registry
  WriteRegStr HKLM "SOFTWARE\Kelp ${VERSION} for JDeveloper" "Install_Dir" "$INSTDIR"

  ; Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Kelp ${VERSION} for JDeveloper" "DisplayName" "Kelp ${VERSION} for JDeveloper (remove only)"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Kelp ${VERSION} for JDeveloper" "UninstallString" '"$INSTDIR\uninstall.exe"'
  WriteUninstaller "uninstall.exe"

	; Create Start Menu Shortcuts
  CreateDirectory "$SMPROGRAMS\Kelp ${VERSION} for JDeveloper"
  CreateShortCut "$SMPROGRAMS\Kelp ${VERSION} for JDeveloper\Uninstall.lnk" \
  							 "$INSTDIR\uninstall.exe" \
  							 "" \
  							 "$INSTDIR\uninstall.exe" 0

	; Create Shortcuts for Tutorial file  							 
  CreateShortCut "$SMPROGRAMS\Kelp ${VERSION} for JDeveloper\Quick start.lnk" \
                 "$INSTDIR\jdev\kelp\doc\kelp_jdeveloper.html" \
                 "" \
                 "$INSTDIR\jdev\kelp\doc\jdeveloper-install.ico" 0
	
	end:
  GetTempFileName $0
  StrCpy $0 "$INSTDIR\install.log"
  Push $0
  Call DumpLog	
SectionEnd
;------------------------------------------------------------------------------
;Installer Functions
;------------------------------------------------------------------------------
Function .onInit

# start splash screen
# the plugins dir is automatically deleted when the installer exits
		InitPluginsDir
		File /oname=$PLUGINSDIR\splash.bmp "${NSISDIR}\Modern UI\KelpForJDeveloper.bmp"
#optional
#File /oname=$PLUGINSDIR\splash.wav "C:\myprog\sound.wav"
		advsplash::show 1000 600 400 -1 $PLUGINSDIR\splash
		Pop $0 ; $0 has '1' if the user closed the splash screen early,
		                ; '0' if everything closed normal, and '-1' if some error occured.
# end splash screen

  ;Extract Install Options INI Files
  !insertmacro MUI_INSTALLOPTIONS_EXTRACT "jdeveloper.ini"
  !insertmacro MUI_INSTALLOPTIONS_EXTRACT "jdk14x.ini"

#  ReadRegStr $R0 HKLM "SOFTWARE\JDeveloper\903" "PATH" 
#  StrCmp $R0 "" continue
#  StrCpy $INSTDIR $R0
#  continue:

FunctionEnd
;---------------------------------------------------------------------------------
; Call when installation succeed
;---------------------------------------------------------------------------------
Function .onInstSuccess
FunctionEnd
;------------------------------------------------------------------------------
;Descriptions
;------------------------------------------------------------------------------
!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES
;------------------------------------------------------------------------------
;Uninstaller Section
;------------------------------------------------------------------------------
Section "Uninstall"
 
  ; remove registry keys
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Kelp ${VERSION} for JDeveloper"
  DeleteRegKey HKLM "SOFTWARE\Kelp ${VERSION} for JDeveloper"

  ; MUST REMOVE UNINSTALLER, too
  Delete $INSTDIR\uninstall.exe

  ; remove shortcuts, if any.
  Delete "$SMPROGRAMS\Kelp ${VERSION} for JDeveloper\*.*"

  ; remove directories used.
  RMDir "$SMPROGRAMS\Kelp ${VERSION} for JDeveloper"
  RMDir /r "$INSTDIR\jdev\kelp"
  RMDir /r "$INSTDIR\jdev\lib\ext\kelpLib"
  Delete "$INSTDIR\jdev\lib\ext\kelp.jar"
  Delete "$INSTDIR\install.log"
  
SectionEnd
;------------------------------------------------------------------------------
;Uninstaller Functions
;------------------------------------------------------------------------------
Function un.onInit

  ;Get language from registry
  ReadRegStr $LANGUAGE HKCU "Software\${MUI_PRODUCT}" "Installer Language"

FunctionEnd
;------------------------------------------------------------------------------
; GetParent
; input, top of stack  (i.e. C:\Program Files\Poop)
; output, top of stack (replaces, with i.e. C:\Program Files)
; modifies no other variables.
;
; Usage:
;   Push "C:\Program Files\Directory\Whatever"
;   Call GetParent
;   Pop $0
;   ; at this point $0 will equal "C:\Program Files\Directory"
;------------------------------------------------------------------------------
Function GetParent
  Exch $0 ; old $0 is on top of stack
  Push $1
  Push $2
  StrCpy $1 -1
  loop:
    StrCpy $2 $0 1 $1
    StrCmp $2 "" exit
    StrCmp $2 "\" exit
    IntOp $1 $1 - 1
  Goto loop
  exit:
    StrCpy $0 $0 $1
    Pop $2
    Pop $1
    Exch $0 ; put $0 on top of stack, restore $0 to original value
FunctionEnd
;------------------------------------------------------------------------------
; Page to choose java home directory and Enhydra install directory
;------------------------------------------------------------------------------
Function SetCustomPage

  Call CheckEnhydraInstall  ; check if installation of Enhydra 5.1 exist
	Call IfJavaExist          ; check if JAVA_HOME directory exist

	start:

  !insertmacro MUI_HEADER_TEXT "$(TEXT_IO_TITLE)" "$(TEXT_IO_SUBTITLE)"
  !insertmacro MUI_INSTALLOPTIONS_DISPLAY_RETURN "jdeveloper.ini"
	Pop $R0
  
   StrCmp $R0 "cancel" end
   StrCmp $R0 "back" end
   StrCmp $R0 "success" 0 error


  !insertmacro MUI_INSTALLOPTIONS_READ ${TEMP1} "jdeveloper.ini" "Field 2" "State" ;Enhydra Directory
  !insertmacro MUI_INSTALLOPTIONS_READ ${TEMP2} "jdeveloper.ini" "Field 4" "State" ;JDK Directory

	IfFileExists ${TEMP2}\bin\java.exe continue	; check if java.exe exist
	MessageBox MB_OK "File java.exe does not exist in directory ${TEMP2}\bin"
	Goto start
		
	continue:
	IfFileExists ${TEMP2}\bin\javac.exe checkJDK	; check if javac.exe exist
	MessageBox MB_OK "File javac.exe does not exist in directory ${TEMP2}\bin"
	Goto start

	checkJDK:
	IfFileExists ${TEMP2}\jre\lib\jsse.jar checkEnhydra	; check if JDK 1.4.x
	MessageBox MB_OK "File jsse.jar does not exist in directory ${TEMP2}\jre\lib"
	Goto start

	checkEnhydra:
	IfFileExists ${TEMP1}\lib\enhydra.jar end	; check if Enhydra exist
	MessageBox MB_OK "File enhydra.jar does not exist in directory ${TEMP1}\lib"
	Goto start

  error:
    MessageBox MB_OK|MB_ICONSTOP "InstallOptions error:$\r$\n${TEMP1}"

	end:
	Pop $R0
FunctionEnd
;------------------------------------------------------------------------------
; Check if choosed java home directory
;------------------------------------------------------------------------------
Function IfJavaExist

  !insertmacro MUI_INSTALLOPTIONS_WRITE "jdeveloper.ini" "Settings" "Title" "$(TEXT_IO_PAGECUSTOM_A)"
  !insertmacro MUI_INSTALLOPTIONS_WRITE "jdeveloper.ini" "Field 1" "Text" "$(TEXT_IO_PAGESUBTITLE_A)"
  !insertmacro MUI_INSTALLOPTIONS_READ ${TEMP2} "jdeveloper.ini" "Field 4" "State"

  StrCmp ${TEMP2} "" end
  
	; predict if exist enviroment variable JAVA_HOME
  ReadEnvStr $6 "JAVA_HOME"

  StrCmp $6 "" notsetJAVA_HOME

	IfFileExists $6\bin\javac.exe OK ; check if javac.exe exist
	Goto notsetJAVA_HOME

  notsetJAVA_HOME:
 	ReadRegStr $6 HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\java.exe" "Path"
 	Push $6
  StrCmp $6 "" notregjava
 	Call GetParent
 	Pop $6
  StrCmp $6 "" notregjava
	IfFileExists $6\bin\javac.exe OK	; check if javac.exe exist
	Goto notregjava

	notregjava:
	ReadRegStr $1 HKLM "SOFTWARE\JavaSoft\Java Development Kit" "CurrentVersion"
	ReadRegStr $6 HKLM "SOFTWARE\JavaSoft\Java Development Kit\$1" "JavaHome"
 	Push $6
#  StrCmp $6 "" end
# 	Call GetParent
# 	Pop $6
	IfFileExists $6\bin\javac.exe OK	; check if javac.exe exist
	Goto end

	OK:
  !insertmacro MUI_INSTALLOPTIONS_WRITE "jdeveloper.ini" "Field 4" "State" "$6"
	
	end:
FunctionEnd
;------------------------------------------------------------------------------
; Call on installation failed
;------------------------------------------------------------------------------
Function .onInstFailed
	Call Cleanup
FunctionEnd
;------------------------------------------------------------------------------
; Call when installation failed 
;------------------------------------------------------------------------------
Function Cleanup
  
  ; remove registry keys
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Kelp ${VERSION} for JDeveloper"
  DeleteRegKey HKLM "SOFTWARE\Kelp ${VERSION} for JDeveloper"

  ; MUST REMOVE UNINSTALLER, too
  Delete $INSTDIR\uninstall.exe

  ; remove shortcuts, if any.
  Delete "$SMPROGRAMS\Kelp ${VERSION} for JDeveloper\*.*"

  ; remove directories used.
  RMDir "$SMPROGRAMS\Kelp ${VERSION} for JDeveloper"
  RMDir /r "$INSTDIR\jdev\kelp"
  RMDir /r "$INSTDIR\jdev\lib\ext\kelpLib"
  Delete "$INSTDIR\jdev\lib\ext\kelp.jar"

FunctionEnd
;------------------------------------------------------------------------------
; ReplaceChar
; input, input string  (C:\JBuilder\jdk1.3.1)
;        char to need replaced (\)
;        char to with replaced (/)
; output, top of stack (C:/JBuilder/jdk1.3.1)
; modifies no other variables.
;
; Usage:
;   Push $1 ; "C:\JBuilder\jdk1.3.1"
;   Push "\"
;   Push "/"
;   Call ReplaceChar
;   Pop $0
;   ; at this point $0 will equal "C:/JBuilder/jdk1.3.1"
;------------------------------------------------------------------------------
Function ReplaceChar
					; stack="/","\","C:\JBuilder\jdk1.3.1", ... (from top to down)
  Exch $2 ; $2="/", stack="2-gi param","\","C:\JBuilder\jdk1.3.1", ...
  Exch  	; stack="\","2-ti param","C:\JBuilder\jdk1.3.1", ...
  Exch $1 ; $1="\", stack="1-vi param","2-gi param","C:\JBuilder\jdk1.3.1", ...
  Exch    ; stack="2-gi param","1-vi param","C:\JBuilder\jdk1.3.1", ...
	Exch 2	; stack="C:\JBuilder\jdk1.3.1","1-vi param","2-gi param", ...
  Exch $0 ; $0="C:\JBuilder\jdk1.3.1", stack="0-ti param","1-vi param","2-gi param", ...
  Exch 2  ; stack="2-gi param","1-vi param","0-ti param", ...

  Push $3	; Len("C:\JBuilder\jdk1.3.1")
  Push $4	; index of string
  Push $5 ; tmp - form strat to found char witch need to change
  Push $6 ; tmp - from found char witch need to change + 1 to end ($3)
  Push $7 ; tmp - position where found char witch need to change + 1
  StrLen $3 $0
  StrCpy $4 1
  loop:
    StrCpy $5 $0 1 $4
    StrCmp $5 "" exit
    StrCmp $5 $1 change
    IntOp $4 $4 + 1
  Goto loop
  change:
  	StrCpy $6 $4				; pozition where found char witch need to change
  	StrCpy $5 $0 $6   	; $5="C:"
  	StrCpy $5 "$5$2"   	; $5="C:/"
  	StrCpy $7 $4				; pozition where found char witch need to change
  	IntOp $7 $7 + 1 		; next pozition
  	StrCpy $6 $0 $3 $7  ; $6="JBuilder\jdk1.3.1"
  	StrCpy $0 $5				; $0="C:/"
  	StrCpy $0 "$0$6" 		; $0="C:/JBuilder\jdk1.3.1"
  Goto loop
  exit:
    Pop $7
    Pop $6
    Pop $5
    Pop $4
    Pop $3
    Pop $2
    Pop $1
    Exch $0 ; put $0 on top of stack, restore $0 to original value
FunctionEnd
;--------------------------------------------------------------------------
; Check if Enhydra Server installation exist
;--------------------------------------------------------------------------
Function CheckEnhydraInstall
  
  ReadRegStr $R0 HKLM "SOFTWARE\Enhydra${VERSION}" "Install_Dir" 
  StrCmp $R0 "" end
  ; set installation directory to <ENHYDRA_ROOT>\Director
  !insertmacro MUI_INSTALLOPTIONS_WRITE "jdeveloper.ini" "Field 2" "State" $R0 
  
  end:
FunctionEnd
;====================================================
; StrStr - Finds a given string in another given string.
;               Returns -1 if not found and the pos if found.
;          Input: head of the stack - string to find
;                      second in the stack - string to find in
;          Output: head of the stack
;====================================================
Function StrStr
  Push $0
  Exch
  Pop $0 ; $0 now have the string to find
  Push $1
  Exch 2
  Pop $1 ; $1 now have the string to find in
  Exch
  Push $2
  Push $3
  Push $4
  Push $5

  StrCpy $2 -1
  StrLen $3 $0
  StrLen $4 $1
  IntOp $4 $4 - $3

  StrStr_loop:
    IntOp $2 $2 + 1
    IntCmp $2 $4 0 0 StrStrReturn_notFound
    StrCpy $5 $1 $3 $2
    StrCmp $5 $0 StrStr_done StrStr_loop

  StrStrReturn_notFound:
    StrCpy $2 -1

  StrStr_done:
    Pop $5
    Pop $4
    Pop $3
    Exch $2
    Exch 2
    Pop $0
    Pop $1
FunctionEnd
;------------------------------------------------------------------------------
; Page for choose java home directory
; 
; set property 'SetJavaHome' in <JDEVELOPER_HOME>/jdev/bin/jdev.conf to <JDK1.4_HOME>, i.e.: 
; SetJavaHome c:/j2sdk1.4.1
; set property 'SetJavaVM' in <JDEVELOPER_HOME>/jdev/bin/jdev.conf to client, i.e.: 
; SetJavaVM client
;------------------------------------------------------------------------------
Function SetCustomPageJDK

  StrCpy $R9 0 ; keep if selected upgrade the shared JDK definition to JDK 1.4.x
  
; set values in jdk14x.ini file
  !insertmacro MUI_INSTALLOPTIONS_WRITE "jdk14x.ini" "Settings" "Title" "$(TEXT_IO_TITLE_A_JDK)"
  !insertmacro MUI_INSTALLOPTIONS_WRITE "jdk14x.ini" "Field 1" "Text" "$(TEXT_IO_PAGESUBTITLE_A_JDK)"
  !insertmacro MUI_INSTALLOPTIONS_WRITE "jdk14x.ini" "Field 2" "Text" "$(TEXT_IO_PAGESUBTITLE_B_JDK)"
  !insertmacro MUI_INSTALLOPTIONS_WRITE "jdk14x.ini" "Settings" "CancelButtonText" "$(TEXT_IO_CANCEL_A_JDK)"
  !insertmacro MUI_INSTALLOPTIONS_WRITE "jdk14x.ini" "Settings" "NextButtonText" "$(TEXT_IO_NEXT_A_JDK)"
  !insertmacro MUI_INSTALLOPTIONS_WRITE "jdk14x.ini" "Settings" "BackButtonText" "$(TEXT_IO_BACK_A_JDK)"
  !insertmacro MUI_HEADER_TEXT "$(TEXT_IO_TITLE_JDK)" "$(TEXT_IO_SUBTITLE_JDK)"

  !insertmacro MUI_INSTALLOPTIONS_DISPLAY_RETURN "jdk14x.ini"
	Pop $R0
  
   StrCmp $R0 "cancel" end
   StrCmp $R0 "back" end
   StrCmp $R0 "success" 0 error

  ; check if check box is selected
  !insertmacro MUI_INSTALLOPTIONS_READ $R1 "jdk14x.ini" "Field 3" "state" 
  StrCmp $R1 "0" end ; check if check box is selected
  StrCpy $R9 1
  Goto end
  
  error:
    MessageBox MB_OK|MB_ICONSTOP "InstallOptions error:$\r$\n${TEMP1}"

  end:
FunctionEnd
;-------------------------------------------------------------------------------
; Usage:
; Push "string1|string2|string3|string4|string5" 
; Call SplitFirstStrPart 
; Pop $R0 ;1st part ["string1"] 
; Pop $R1 ;rest ["string2|string3|string4|string5"] 
;-------------------------------------------------------------------------------
Function SplitFirstStrPart
  Exch $R0
  Push $R1
  Push $R2
  StrLen $R1 $R0
  IntOp $R1 $R1 + 1
  loop:
    IntOp $R1 $R1 - 1
    StrCpy $R2 $R0 1 -$R1
    StrCmp $R1 0 exit0
    StrCmp $R2 " " exit1 loop ; Change " " to "\" if str=dirpath
  exit0:
  StrCpy $R1 ""
  Goto exit2
  exit1:
    IntOp $R1 $R1 - 1
    StrCpy $R2 $R0 "" -$R1
    IntOp $R1 $R1 + 1
    StrCpy $R0 $R0 -$R1
    StrCpy $R1 $R2
  exit2:
  Pop $R2
  Exch $R1 ;rest
  Exch
  Exch $R0 ;first
FunctionEnd
;--------------------------------------------------------------------------
; Upgrade the JDK definition to JDK 1.4.x in file ide.cfg
;--------------------------------------------------------------------------
Function UpgradeJDKConfig
#  $R5 $INSTDIR
#  $2 Enhydra Directory
#  $3 JDK Directory

ClearErrors
IfFileExists "$R5\jdev\bin\jdev.conf.save" 0 start
Delete "$R5\jdev\bin\jdev.conf.save"

start:
FileOpen $9 "$R5\jdev\bin\jdev.conf" "r"
GetTempFileName $R4
FileOpen $8 $R4 "w"

StrCpy $5 0
StrCpy $4 0

loop:
   FileRead $9 $6
   IfErrors done
   
   Push $6
   Push "SetJavaHome"
   Call StrStr ; Find "SetJavaHome" in $6
   Pop $0 ; pos of SetJavaHome
   StrCmp $0 "-1" setjavavm setjavahome 

   setjavavm:
   Push $6
   Push "SetJavaVM"
   Call StrStr ; Find "SetJavaVM" in $6
   Pop $0 ; pos of SetJavaVM
   StrCmp $0 "-1" writeTempFile changesetjavavm 

writeTempFile:   
   FileWrite $8 $6
   Goto loop

setjavahome: 
   StrCmp $0 "0" "" setjavahome1
   StrCpy $5 1
   FileWrite $8 "#$6" 
   FileWrite $8 "SetJavaHome $3$\r$\n" 
   Goto loop 
setjavahome1: 
;  check if first char is '#'  
   Push $6
   Push "#"
   Call StrStr ; Find "SetJavaHome" in $6
   Pop $0 ; pos of SetJavaHome
   StrCmp $0 "0" writeTempFile
   StrCpy $5 1
   FileWrite $8 "#$6" 
   FileWrite $8 "SetJavaHome $3$\r$\n" 
   Goto loop 

changesetjavavm: 
   StrCmp $0 "0" "" changesetjavavm1
   StrCpy $4 1
   FileWrite $8 "#$6" 
   FileWrite $8 "SetJavaVM client$\r$\n" 
   Goto loop 
changesetjavavm1: 
;  check if first char is '#'  
   Push $6
   Push "#"
   Call StrStr ; Find "SetJavaVM" in $6
   Pop $0 ; pos of SetJavaVM
   StrCmp $0 "0" writeTempFile
   StrCpy $4 1
   FileWrite $8 "#$6" 
   FileWrite $8 "SetJavaVM client$\r$\n" 
   Goto loop 
   
done:
   StrCmp $5 "0" "" done1
   FileWrite $8 "SetJavaHome $3$\r$\n" 
done1:
   StrCmp $4 "0" "" done2
   FileWrite $8 "SetJavaVM client$\r$\n" 
done2:
   FileClose $9
   FileClose $8
#   MessageBox MB_OK "$R5\jdev\bin\jdev.conf $R5\jdev\bin\jdev.conf.save"
   Rename "$R5\jdev\bin\jdev.conf" "$R5\jdev\bin\jdev.conf.save"
#   MessageBox MB_OK "$R4$ $R5\jdev\bin\jdev.conf"
   CopyFiles /SILENT $R4 "$R5\jdev\bin\jdev.conf"
   Delete $R4
   StrCpy $0 0	; set OK
   
FunctionEnd
!define LVM_GETITEMCOUNT 0x1004
!define LVM_GETITEMTEXT 0x102D

Function DumpLog
  Exch $5
  Push $0
  Push $1
  Push $2
  Push $3
  Push $4
  Push $6

  FindWindow $0 "#32770" "" $HWNDPARENT
  GetDlgItem $0 $0 1016
  StrCmp $0 0 exit
  FileOpen $5 $5 "w"
  StrCmp $5 "" exit
    SendMessage $0 ${LVM_GETITEMCOUNT} 0 0 $6
    System::Alloc ${NSIS_MAX_STRLEN}
    Pop $3
    StrCpy $2 0
    System::Call "*(i, i, i, i, i, i, i, i, i) i \
      (0, 0, 0, 0, 0, r3, ${NSIS_MAX_STRLEN}) .r1"
    loop: StrCmp $2 $6 done
      System::Call "User32::SendMessageA(i, i, i, i) i \
        ($0, ${LVM_GETITEMTEXT}, $2, r1)"
      System::Call "*$3(&t${NSIS_MAX_STRLEN} .r4)"
      FileWrite $5 "$4$\r$\n"
      IntOp $2 $2 + 1
      Goto loop
    done:
      FileClose $5
      System::Free $1
      System::Free $3
  exit:
    Pop $6
    Pop $4
    Pop $3
    Pop $2
    Pop $1
    Pop $0
    Exch $5
FunctionEnd