#! /bin/bash
name=kelp
version=$(ls -1d kelp-*| grep -v 'tar.gz' |sed 's/kelp-//')
version=${version:=5.1}
	default_jdkdir=$(dirname $(which java 2>/dev/null) 2>/dev/null)/..
	if
		[[ $default_jdkdir = '/..' ]]
	then
		default_jdkdir=/usr/java/j2sdk1.4.0_01
	else
		cd $default_jdkdir
		default_jdkdir=$PWD
		cd -
	fi
	echo -e "\n\n ${name}-NetBeans-${version} installation script\n\n"
	JDK_HOME=${JDK_HOME:=$JAVA_HOME}
        while
                err=0
                if
                        [ X$JDK_HOME = X ]
                then
                        text="Warning: JDK_HOME is not defined."
                        err=1
                elif
                        [ ! -d $JDK_HOME ]
                then
                        text="Warning: No such directory: $JDK_HOME."
                        err=1
                elif
                        [ ! -r $JDK_HOME/bin/javac ]
                then
                        text="Warning: Not a valid directory (no javac file): $JDK_HOME."
                        err=1
                fi
                [ $err -gt 0 ]
        do
                echo $text
                echo -e "\n\nPlease enter path to your "\
                        "Java Development Kit - JDK directory [$default_jdkdir] \c"
                read JDK_HOME </dev/tty
                JDK_HOME=${JDK_HOME:=$default_jdkdir}
        done
        export JDK_HOME
	PATH=$JDK_HOME/bin:$PATH
	export PATH
        tools=$(find $JDK_HOME -name tools.jar -print)
        if
                echo $CLASSPATH | grep -v $tools
        then
                CLASSPATH=$CLASSPATH:$tools
                export CLASSPATH
        fi
	
	default_enhdir=/usr/local/enhydra5.1
        while
                echo -e "\n\nPlease enter path to your "\
                        "Enhydra root directory [$default_enhdir] \c"
                read enhdir </dev/tty
                enhdir=${enhdir:=$default_enhdir}
                [ ! -d $enhdir ]
        do
                echo "Warning: No such directory: $enhdir"
        done
	default_nbdir=/opt/netbeans
        while
                echo -e "\n\nPlease enter path to your "\
                        "NetBeans root directory [$default_nbdir] \c"
                read nbdir </dev/tty
                nbdir=${nbdir:=$default_nbdir}
                [ ! -d $nbdir ]
        do
                echo "Warning: No such directory: $nbdir"
        done
	major_version=$(echo ${version}| cut -f1 -d'.')
	kelpdir=${nbdir}/Kelp$major_version
	if
		[ ! -d ${kelpdir} ]
	then
		mkdir ${kelpdir}
	else
		echo "Kelp has already been installed, removing the contents of $kelpdir"
		rm -rf  ${kelpdir}/*
		mv -f ${nbdir}/bin/bck/ide.cfg ${nbdir}/bin/
		mv -f ${nbdir}/bin/bck/ide.policy ${nbdir}/bin/
	fi
	cd $(dirname $0)
	mv ${name}-${version}/NetBeans/* ${kelpdir}
	cd ${kelpdir}
	if
		./configure $nbdir $enhdir 
	then
		echo -e "\n\nThe installation has been successful"
	else
		echo -e "\n\nThe installation failed"
		exit 1
	fi


