/*
 * Enhydra Java Application Server Project
 *
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific terms governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 *
 * Contributor(s):
 * Paul Mahar
 *
 */
package org.enhydra.kelp.common;

// ToolBox imports
import org.enhydra.tool.ToolBoxInfo;
import org.enhydra.tool.common.ButtonPanel;
import org.enhydra.tool.common.DialogHandler;
import org.enhydra.tool.common.ProgressMeter;
import org.enhydra.tool.common.SwingUtil;
import org.enhydra.tool.common.event.HelpEvent;
import org.enhydra.tool.common.event.HelpListener;

// Kelp imports
import org.enhydra.kelp.KelpInfo;
import org.enhydra.kelp.common.event.WriteListener;
import org.enhydra.kelp.common.node.OtterProject;
import org.enhydra.kelp.common.swing.AddinInnerPanel;

// Standard imports
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.ResourceBundle;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dialog;
import java.awt.Frame;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.awt.Point;
import java.awt.Window;
import javax.swing.JComponent;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JDialog;

//
abstract public class AbstractTool extends DialogHandler {

    //
    private OtterProject         project = null;

    public AbstractTool() {
        super();
    }

    /**
     * Get the IDE project containing the HTML files.
     */
    public OtterProject getProject() {
        return project;
    }

    /**
     * Set the IDE project containing the HTML files.
     */
    public void setProject(OtterProject p) {
        project = p;
        getAddinInnerPanel().read(getProject());
    }

    public AddinInnerPanel getAddinInnerPanel() {
      return (AddinInnerPanel) getInnerPanel();
    }
}
