package org.enhydra.kelp.eclipse.actions;


import java.lang.reflect.InvocationTargetException;

import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.jdt.core.IJavaElement;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.operation.IRunnableWithProgress;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.externaltools.internal.core.DefaultRunnerContext;
import org.eclipse.ui.externaltools.internal.core.ExternalTool;
import org.enhydra.kelp.eclipse.KelpPlugin;
import org.enhydra.tool.ToolBoxInfo;

/**
 * Insert the type's description here.
 * @see IWorkbenchWindowActionDelegate
 */
public class AntRebuildAction implements IWorkbenchWindowActionDelegate {

	ExternalTool antRebuildTool = null;
	IProject project = null;
	IWorkbenchWindow window = null;

	/**
	 * The constructor.
	 */
	public AntRebuildAction() {
	}

	/**
	 * Insert the method's description here.
	 * @see IWorkbenchWindowActionDelegate#run
	 */
	public void run(IAction action)  {
		String prjName = null;
		String prjPath = null;
		project = null;
		
		IWorkbenchPage page = KelpPlugin.getDefault().getWorkbench().getActiveWorkbenchWindow().getActivePage();
		if (page != null) {
			ISelection selection = page.getSelection();
			if (selection instanceof IStructuredSelection) {
				IStructuredSelection ss = (IStructuredSelection)selection;
				if (!ss.isEmpty()) {
					Object obj = ss.getFirstElement();
					if (obj instanceof IJavaElement) {
						IResource res =((IJavaElement)obj).getResource();
						if (res == null)
							project = ((IJavaElement)obj).getJavaProject().getProject();
						else
							project = res.getProject();
							
					}
					if (obj instanceof IResource) {
							project = ((IResource)obj).getProject();
					}
				}
			}
		}
		if (project != null) {
			prjName = project.getName();
			prjPath = project.getLocation().toString();
		
//---------------------Dacha---------------------------------

			antRebuildTool = new ExternalTool();
			String location = ToolBoxInfo.getEnhydraRoot() + "/bin/ant";
			if (System.getProperty("os.name").toLowerCase().startsWith("windows")) {
				location += ".bat";
			}
			antRebuildTool.setBlock(true);
			antRebuildTool.setBuildTypes(new String[0]); //default: do not include in any rebuild
			antRebuildTool.setLocation(location);
			antRebuildTool.setArguments("rebuild");
			antRebuildTool.setName("Ant Rebuild");
			antRebuildTool.setRefreshScope("${project}");
			antRebuildTool.setShowLog(true);
			antRebuildTool.setType(ExternalTool.TOOL_TYPE_PROGRAM);
			antRebuildTool.setWorkingDirectory("${workspace_loc:/"+prjName+"}");	


            window = PlatformUI.getWorkbench().getActiveWorkbenchWindow();
			IRunnableWithProgress runnable = new IRunnableWithProgress() {
				public void run(IProgressMonitor monitor) throws InvocationTargetException, InterruptedException {
					DefaultRunnerContext context = new DefaultRunnerContext(antRebuildTool, project, window.getWorkbench().getWorkingSetManager());
					context.run(monitor, window.getShell());
				};
			};
			try {
	            window.run(false, false, runnable);				
			} catch (Exception e) {
				e.printStackTrace();
			}
//			try {
//				context.run(null, window.getShell());
//			} catch (Exception e) {
//				e.printStackTrace();
//			}

//			try {
//		
//				// Refresh project, so the generated files could be visible	
//				project.refreshLocal(IResource.DEPTH_INFINITE, null);				
//			} catch (CoreException e) {
//				System.err.println(prjName);
//			}
		}else
			System.err.println("Fail to start Ant Rebuild, no project is selected!");
		
	}

	/**
	 * Insert the method's description here.
	 * @see IWorkbenchWindowActionDelegate#selectionChanged
	 */
	public void selectionChanged(IAction action, ISelection selection)  {
	}

	/**
	 * Insert the method's description here.
	 * @see IWorkbenchWindowActionDelegate#dispose
	 */
	public void dispose()  {
	}

	/**
	 * Insert the method's description here.
	 * @see IWorkbenchWindowActionDelegate#init
	 */
	public void init(IWorkbenchWindow window)  {
	}
}
