package org.enhydra.kelp.eclipse.codegen.wizard;

import org.eclipse.core.resources.IWorkspaceRoot;
import org.enhydra.kelp.eclipse.KelpPlugin;
import org.enhydra.tool.codegen.CodeGen;
import org.enhydra.tool.codegen.Generator;
import org.enhydra.tool.codegen.GeneratorException;
import org.enhydra.tool.codegen.GeneratorOption;
import org.enhydra.tool.codegen.wizard.CodeGenDeck;
import org.enhydra.tool.codegen.wizard.CodeGenWizard;

/**
 * @author Administrator
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class EclipseCodeGenWizard extends CodeGenWizard {
	private String prjName;
	private String prjLocation;

	/**
	 * Constructor for EclipseCodeGenWizard.
	 * @param cg
	 */
	public EclipseCodeGenWizard(CodeGen cg) {
		super(cg);
	}

	/**
	 * Constructor for EclipseCodeGenWizard.
	 * @throws GeneratorException
	 */
	public EclipseCodeGenWizard() throws GeneratorException {
		super();
	}

	/**
	 * Constructor for EclipseCodeGenWizard.
	 * @param name
	 */

	public EclipseCodeGenWizard(String name, String prjRootKelp) throws GeneratorException {//DACHA
		super();

		prjName = name;
		prjLocation = prjRootKelp;
		SetOptions();
	}

	private void SetOptions() {
		int i = 0;

		Generator[] generators = getGenerators();
		GeneratorOption opt;
		try {
			for (i = 0; i < generators.length; i++) {
				opt = generators[i].getOptionSet().lookup("project");
				opt.setValue(prjName);
				opt = generators[i].getOptionSet().lookup("package");
				opt.setValue(prjName);
				opt = generators[i].getOptionSet().lookup("root");
				opt.setValue(prjLocation);
			}
		} catch (GeneratorException e) {
		}
	}

	/**
	 * @see org.enhydra.tool.common.wizard.TBWizard#back()
	 */
	public void back() {
		super.back();

		CodeGenDeck deck = (CodeGenDeck) getDeck();
		if (deck.getPageIndex() == 0)
			SetOptions();
	}
}
