package org.enhydra.kelp.eclipse.actions;

import java.io.File;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.jdt.core.IJavaElement;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;
import org.enhydra.dods.generator.DODSGenerator;
import org.enhydra.kelp.ant.dods.KelpDODSGenerator;
import org.enhydra.kelp.ant.node.AntProject;
import KelpEclipse21.KelpEclipse21Plugin;

/**
 * Insert the type's description here.
 * @see IWorkbenchWindowActionDelegate
 */
public class DODSAction implements IWorkbenchWindowActionDelegate {
	/**
	 * The constructor.
	 */
	public DODSAction() {
	}

	/**
	 * Insert the method's description here.
	 * @see IWorkbenchWindowActionDelegate#run
	 */
	public void run(IAction action)  {
		IProject project = null;
		String prjName = null;
		String prjPath = null;

		IWorkbenchPage page = KelpEclipse21Plugin.getDefault().getWorkbench().getActiveWorkbenchWindow().getActivePage();
		if (page != null) {
			ISelection selection = page.getSelection();
			if (selection instanceof IStructuredSelection) {
				IStructuredSelection ss = (IStructuredSelection)selection;
				if (!ss.isEmpty()) {
					Object obj = ss.getFirstElement();
					if (obj instanceof IJavaElement) {
						IResource res =((IJavaElement)obj).getResource();
						if (res == null)
							project = ((IJavaElement)obj).getJavaProject().getProject();
						else
							project = res.getProject();
							
					}
					if (obj instanceof IResource) {
							project = ((IResource)obj).getProject();
					}
				}
			}
		}
		if (project != null) {
			prjName = project.getName();
			prjPath = project.getLocation().toString();
		
//---------------------Dacha---------------------------------
			try{
				if(prjPath!=null){
					AntProject antProject = new AntProject(prjPath);
                	String enhydraDir = antProject.getProperty(AntProject.ENHYDRA_DIR);
                	File dodsDirFile = new File(enhydraDir,"dods");
                	System.setProperty("DODS_HOME", dodsDirFile.getAbsolutePath());
               		KelpDODSGenerator.main(new String[]{prjPath});
				}		
			}catch(Exception e){
				e.printStackTrace();
			}
			// Refresh project, so the generated files could be visible	
			try {
				project.refreshLocal(IResource.DEPTH_INFINITE, null);				
			} catch (CoreException e) {
				System.err.println(prjName);
			}
		}else	
			System.err.println("Fail to start DODS Generator, no project is selected!");

	}

	/**
	 * Insert the method's description here.
	 * @see IWorkbenchWindowActionDelegate#selectionChanged
	 */
	public void selectionChanged(IAction action, ISelection selection)  {
	}

	/**
	 * Insert the method's description here.
	 * @see IWorkbenchWindowActionDelegate#dispose
	 */
	public void dispose()  {
	}

	/**
	 * Insert the method's description here.
	 * @see IWorkbenchWindowActionDelegate#init
	 */
	public void init(IWorkbenchWindow window)  {
	}
}
