package org.enhydra.kelp.jbuilder.actions;

import com.borland.primetime.ide.Browser;
import com.borland.primetime.ide.BrowserAction;
import javax.swing.AbstractAction;
import org.enhydra.kelp.ant.dods.KelpDODSGenerator;
import com.borland.primetime.node.Project;
import com.borland.primetime.vfs.Url;
import com.borland.jbuilder.node.JBProject;
import java.io.File;
import org.enhydra.kelp.ant.node.AntProject;

public class DODSAction extends BrowserAction
{

  public DODSAction(String s, char c) {
    super(s, c);
  }

  public void actionPerformed(Browser browser) {
    String prjPath = null;
    JBProject project = (JBProject)browser.getActiveUserProject();
    if (project != null) {
      try {
        prjPath = project.getProjectPath().getFullName();
        AntProject antProject = new AntProject(prjPath);
        String enhydraDir = antProject.getProperty(AntProject.ENHYDRA_DIR);
        File dodsDirFile =  new File(enhydraDir, "dods");
        System.setProperty("DODS_HOME", dodsDirFile.getAbsolutePath());
        KelpDODSGenerator.main(new String[] {prjPath});
      }
      catch (Exception ex) {
        ex.printStackTrace();
      }
      project.refresh();
    }
  }

  /**
   * Enables deploy action if current project exists and if it is JBProject type
   * and if exist builder.xml file in the project
   *
   * @param browser
   */
  public void update(Browser browser) {
    JBProject project;
    if (browser.getActiveProject() != null) {
      project = (JBProject)browser.getActiveProject();
      setEnabled( (project instanceof JBProject) &&
                  (project.getProperty("enhydra.project", "false")
                    .equalsIgnoreCase("true")) );
    } else {
      setEnabled(false);
    }
  }

}