package org.enhydra.kelp.jdev;
import oracle.ide.Ide;
import oracle.ide.addin.Addin;
import java.lang.String;
import oracle.ide.util.MenuSpec;
import oracle.ide.addin.Context;
import javax.swing.Icon;
import java.net.URL;
import javax.swing.ImageIcon;
import oracle.ide.addin.Wizard;
import javax.swing.JMenuItem;
import oracle.ide.IdeAction;
import oracle.ide.addin.Controller;
import oracle.ide.ContextMenu;
import oracle.ide.addin.ContextMenuListener;
import javax.swing.JOptionPane;

public class EnhydraAppWizard implements Addin, Wizard, Controller//, ContextMenuListener 
{
  private static JMenuItem contextMenuItem = null;

  // %%TODO: Change this ID to something related to your command
  public static final int ENHYDRA_APP_WIZARD_ID = Ide.newCmd("org.enhydra.kelp.jdev.EnhydraAppWizard.ENHYDRA_APP_WIZARD_ID");
  private final static String GALLERY_ICON = "/media/gallery_16x16.gif";
  
  private JMenuItem menuItem = null;
  private Icon _icon;

  public EnhydraAppWizard()
  {
  }

  public void initialize()
  {
    // Do not do major initialization here, it can slow down the startup of JDeveloper
//    Ide.getNavigatorManager().addContextMenuListener(this, null);
  }

  public void shutdown()
  {
    // Do any necessary cleanup here
  }

  public float version()
  {
    // return the version of your extension
    return 1.0f;
  }

  public float ideVersion()
  {
    return Ide.IDE_VERSION;
  }

  public boolean canShutdown()
  {
    return true;
  }

  public String getName()
  {
    return "EnhydraAppWizard";
  }

  public String getMenuLabel()
  {
    return null;
  }

  public MenuSpec getMenuSpecification()
  {
    return null;
  }

  public boolean isAvailable(Context context)
  {
    return true;
  }

  public Icon getIcon()
  {
    if (_icon == null)
    {
      URL url = getClass().getResource(GALLERY_ICON);
      if (url != null)
      {
        _icon = new ImageIcon(url);
      }
    }
    return _icon;
  }

  public boolean invoke(Context context, String[] params)
  {
    // Invocation: Display message dialog
    if (Ide.getActiveWorkspace() != null)
    {
      System.out.println("Current Workspace : " + Ide.getActiveWorkspace().getShortLabel());
      new RealWizard(context);
    }
    else
    {
      JOptionPane.showMessageDialog(null,
                                    "Please select a Workspace",
                                    "Ooops",
                                    JOptionPane.WARNING_MESSAGE);
    }
    return true;
  }

  private Icon loadIcon(String iconName)
  {
    URL url = getClass().getResource(iconName);
    Icon icon = null;
    if (url != null)
    {
      icon = new ImageIcon(url);
    }
    return icon;
  }

  private JMenuItem createMenu_ENHYDRA_APP_WIZARD_ID(String iconName, String menuLabel, int mnemonic)
  {
    // String class name which extends oracle.ide.addin.AbstractCommand or null
    String cmdClass = null;
    // Category of the keymap to which this entry belongs
    String category = null;
    // Icon for the menu item
    Icon icon = loadIcon(iconName);
    // Data to be associated with the Action
    Object data = null;
    // Should the action be enabled by default
    boolean enabled = true;

    IdeAction action;
    // Create the IdeAction
    action = IdeAction.get(ENHYDRA_APP_WIZARD_ID, cmdClass, menuLabel, category, new Integer(mnemonic), icon, data, enabled);
    // Set the default controller for this action
    action.setController(this);
    // Create MenuItem
    JMenuItem menuItem = Ide.getMenubar().createMenuItem(action);
    return menuItem;
  }

  public Controller supervisor()
  {
    return null;
  }

  public boolean handleEvent(IdeAction action, Context context)
  {
    final int cmdId = action.getCommandId();
    if (cmdId == org.enhydra.kelp.jdev.EnhydraAppWizard.ENHYDRA_APP_WIZARD_ID)
    {
      invoke(context, null);
      return true;
    }
    return false;
  }

  public boolean update(IdeAction action, Context context)
  {
    final int cmdId = action.getCommandId();
    if (cmdId == org.enhydra.kelp.jdev.EnhydraAppWizard.ENHYDRA_APP_WIZARD_ID)
    {
      action.setEnabled(is_ENHYDRA_APP_WIZARD_ID_Available(context));
      return true;
    }
    return false;
  }

  private boolean is_ENHYDRA_APP_WIZARD_ID_Available(Context context)
  {
    // %%TODO: Modify this method to the enabled state of the command.
    return true;
  }

  public void checkCommands(Context action, Controller controller)
  {
    // If your command is on the main menu and has an accelerator you need to call update from here
    // If your command is on the toolbar then you also must call update from here
  }

}