package org.enhydra.kelp.ant.deployer;

import java.awt.*;
import javax.swing.*;
import org.enhydra.tool.swing.layout.*;
//import com.borland.jbcl.layout.*;
import javax.swing.border.*;
import org.enhydra.kelp.ant.node.AntProject;
import org.enhydra.kelp.common.node.OtterProject;
import java.util.ResourceBundle;
import java.awt.event.*;
import javax.swing.JFileChooser;
import java.io.File;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class AntDeployGeneralPanel extends JPanel {

    static ResourceBundle res = ResourceBundle.getBundle(
            "org.enhydra.kelp.common.Res");

    private XYLayout xYLayout1 = new XYLayout();
    JLabel jLabelDescr = new JLabel();
    JLabel jLabelType = new JLabel();
    JTextField jTextType = new JTextField();
    JLabel jLabelRoot = new JLabel();
    JTextField jTextDestination = new JTextField();
    JButton jButtonBrowse = new JButton();
    JCheckBox jCheckInvokeMake = new JCheckBox();
    AntProject project = null;
    private JCheckBox jCheckBoxMakeWAR = new JCheckBox();
    private JCheckBox jCheckBoxEnhydraLib = new JCheckBox();

    public AntDeployGeneralPanel() {
        try {
            jbInit();
        }
        catch(Exception ex) {
            ex.printStackTrace();
        }
    }

    public void setProject(OtterProject otterProject){
        if(otterProject instanceof AntProject) {
            project = (AntProject) otterProject;
            initOptions();
        }
        else
            System.err.println("DEBUG project must be AntProject");//FIXME throw Exception
    }

    private void initOptions() {
        if (project.isWebType()) {
            jTextType.setText(res.getString("Web_Application"));
            jCheckBoxMakeWAR.setVisible(false); //by default WAR is created for Web app
        }
        else {
            jTextType.setText(res.getString("Enhydra_Super_Servlet"));
            jCheckBoxMakeWAR.setVisible(true);
            
            if(project.getProperty(AntProject.DEPLOY_WAR_ENABLED).equalsIgnoreCase("true")){
                jCheckBoxMakeWAR.setSelected(true);
                jCheckBoxEnhydraLib.setVisible(true);
            }else{
                jCheckBoxMakeWAR.setSelected(false);
                jCheckBoxEnhydraLib.setVisible(false);
            }
        }
        if(project.getProperty(AntProject.DEPLOY_WAR_ENHYDRA_LIBS).equalsIgnoreCase("true")){
                jCheckBoxEnhydraLib.setSelected(true);
        }else{
                jCheckBoxEnhydraLib.setSelected(false);
        }
        jTextDestination.setText(project.getProperty(AntProject.OUTPUT_DIR));
        if(project.getProperty(AntProject.DEPLOY_INVOKE).equalsIgnoreCase("true"))
            jCheckInvokeMake.setSelected(true);
        else
            jCheckInvokeMake.setSelected(false);


    }

    public OtterProject getProject(){
        return (OtterProject) project;
    }

    void jbInit() throws Exception {
        jLabelDescr.setFont(new java.awt.Font("Dialog", 1, 12));
        jLabelDescr.setText(res.getString("General_deployment_options"));
        this.setLayout(xYLayout1);
        jLabelType.setText(res.getString("Deploy_type"));
        jTextType.setBackground(SystemColor.control);
        jTextType.setEditable(false);
        jLabelRoot.setText(res.getString("Deploy_destination_directory"));
        jButtonBrowse.setText(res.getString("Browse"));
        jButtonBrowse.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButtonBrowse_actionPerformed(e);
            }
        });
        jCheckInvokeMake.setText(res.getString("Deploy_during_make"));
        jCheckInvokeMake.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jCheckInvokeMake_actionPerformed(e);
            }
        });

        jTextDestination.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(FocusEvent e) {
                jTextDestination_focusLost(e);
            }
        });

        jCheckBoxMakeWAR.setText("Make WAR (Web Archive)");
        jCheckBoxMakeWAR.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jCheckBoxMakeWAR_actionPerformed(e);
            }
        });

        xYLayout1.setWidth(460);
        xYLayout1.setHeight(372);
        jCheckBoxEnhydraLib.setText("Include Enhydra library into WAR");
        jCheckBoxEnhydraLib.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jCheckBoxEnhydraLib_actionPerformed(e);
            }
        });
        this.add(jLabelDescr,  new XYConstraints(13, 13, 178, 18));
        this.add(jCheckInvokeMake, new XYConstraints(13, 55, 258, 20));
        this.add(jLabelType, new XYConstraints(13, 88, 74, 18));
        this.add(jTextType, new XYConstraints(13, 112, 368, 22));
        this.add(jLabelRoot, new XYConstraints(13, 159, 170, 26));
        this.add(jTextDestination, new XYConstraints(13, 189, 267, 22));
        this.add(jButtonBrowse, new XYConstraints(291, 187, 90, 25));
        this.add(jCheckBoxMakeWAR, new XYConstraints(13, 245, 328, 24));
        this.add(jCheckBoxEnhydraLib,      new XYConstraints(13, 277, 368, 32));
    }

    public void jTextDestination_focusLost(FocusEvent fe) {
        project.setProperty(AntProject.OUTPUT_DIR, jTextDestination.getText());
    }

    void jButtonBrowse_actionPerformed(ActionEvent e) {
        browseForDir();
    }

    private void browseForDir() {
        JFileChooser    chooser;
        String          fileDir = new String();
        File            file = null;
        chooser = new JFileChooser();
        chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        file = new File(project.getProperty(AntProject.OUTPUT_DIR));
        if (!file.isAbsolute()) {
            file = new File(project.getWorkingPath(), file.getPath());
        }
        chooser.setCurrentDirectory(file);
        chooser.setDialogTitle(res.getString("chooser_DeployRoot_DialogTitle"));
        chooser.setApproveButtonText(res.getString("OK"));
        int v = chooser.showOpenDialog(this);

        this.requestFocus();
        jButtonBrowse.requestFocus();
        if (v == JFileChooser.APPROVE_OPTION) {
            if (!(chooser.getCurrentDirectory() == null)) {
                fileDir = chooser.getSelectedFile().toString();
                jTextDestination.setText(fileDir);
                project.setProperty(AntProject.OUTPUT_DIR, fileDir);
            }
        }
        chooser.removeAll();
        chooser = null;
    }

    void jCheckInvokeMake_actionPerformed(ActionEvent e) {
        if (jCheckInvokeMake.isSelected()) {
            project.setProperty(AntProject.DEPLOY_INVOKE, "true");
        }
        else {
            project.setProperty(AntProject.DEPLOY_INVOKE, "false");
        }
    }

    void jCheckBoxMakeWAR_actionPerformed(ActionEvent e) {
        if(jCheckBoxMakeWAR.isSelected()){
            project.setProperty(AntProject.DEPLOY_WAR_ENABLED,"true");
            jCheckBoxEnhydraLib.setVisible(true);
        }else{
            project.setProperty(AntProject.DEPLOY_WAR_ENABLED,"false");
            jCheckBoxEnhydraLib.setVisible(false);
        }
    }

    void jCheckBoxEnhydraLib_actionPerformed(ActionEvent e) {
        if(jCheckBoxEnhydraLib.isSelected()){
            project.setProperty(AntProject.DEPLOY_WAR_ENHYDRA_LIBS,"true");
        }else{
            project.setProperty(AntProject.DEPLOY_WAR_ENHYDRA_LIBS,"false");
        }
    }
}