/*
 * Enhydra Java Application Server Project
 *
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific terms governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 *
 * Contributor(s):
 * Paul Mahar
 *
 */
package org.enhydra.kelp.common.deployer;

// ToolBox imports
import org.enhydra.tool.common.ButtonPanel;

// Standard imports
import java.awt.Window;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.lang.ref.WeakReference;
//
public class DeployButtonListener implements ActionListener {
        private WeakReference ref = null;

    	public DeployButtonListener(CoreDeployTool tool) {
          ref = new WeakReference(tool);
    	}

    public void actionPerformed(ActionEvent event) {
        String command = event.getActionCommand();
        if (command.equals(ButtonPanel.COMMAND_BACK)) {
                getTool().back();
        } else if (command.equals(ButtonPanel.COMMAND_NEXT)) {
                getTool().next();
        } else if (command.equals(ButtonPanel.COMMAND_DEPLOY)) {
                getTool().deploy();
        } else if (command.equals(ButtonPanel.COMMAND_CLOSE)) {
                getTool().closeWindow();
        } else if (command.equals(ButtonPanel.COMMAND_HELP)) {
                getTool().notifyHelpListeners(event.getSource());
        } else if (command.equals(ButtonPanel.COMMAND_ABOUT)) {
                getTool().showAbout();
        }
    }

        private CoreDeployTool getTool() {
          return (CoreDeployTool) ref.get();
        }

}
