
/*
 * Enhydra Java Application Server Project
 *
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific terms governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 *
 * Contributor(s):
 * Paul Mahar
 *
 */
package org.enhydra.tool.archive;

// ToolBox
import org.enhydra.tool.common.PathHandle;

//
public class Module {
    private String name = null;
    private String archive = null;

    public Module(String filepath) {
        PathHandle ph = PathHandle.createPathHandle(filepath);

        setName(ph.getFile().getName());
        setArchive(ph.getPath());
    }

    public String getArchive() {
        return archive;
    }

    public void setArchive(String a) {
        archive = a;
    }

    public String getName() {
        return name;
    }

    // override Object
    public boolean equals(Object obj) {
        boolean equal = false;

        if (obj instanceof Module) {
            Module mod = (Module) obj;

            if (mod.getName().equals(getName())) {
                equal = true;
            }
            if (equal) {
                if (!mod.getArchive().equals(getArchive())) {
                    equal = false;
                }
            }
        }
        return equal;
    }

    private void setName(String n) {
        name = n;
    }

}
