
/*
 * Enhydra Java Application Server Project
 *
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific terms governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 *
 * Contributor(s):
 *
 */
package org.enhydra.tool.common;

// Standard imports
import javax.swing.ImageIcon;
//
public class IconSet {
    // strings not to be resourced
    private static final String DELETE_ROW_GIF =
        "org/enhydra/tool/common/media/gallant/DeleteRow.gif"; //nores
    private static final String DOWN_GIF =
        "org/enhydra/tool/common/media/gallant/Down.gif"; //nores
    private static final String ROW_GIF =
        "org/enhydra/tool/common/media/gallant/Row.gif"; //nores
    private static final String LARGE_GIF =
        "org/enhydra/tool/common/media/lutris/largeicon.gif"; // nores
    private static final String NEW_ROW_GIF =
        "org/enhydra/tool/common/media/gallant/NewRow.gif"; //nores
    private static final String WIZARD_JPG =
        "org/enhydra/tool/common/media/lutris/otterwizard.jpg"; //nores
    private static final String SMALL_GIF =
        "org/enhydra/tool/common/media/lutris/smallicon.gif"; // nores
    private static final String UP_GIF =
        "org/enhydra/tool/common/media/gallant/Up.gif"; //nores
    private static final String UNDO_GIF =
        "org/enhydra/tool/common/media/gallant/Undo.gif"; //nores


    public IconSet() {}

    public static ImageIcon getDeleteRowIcon() {
        ImageIcon icon = null;
        icon = new ImageIcon(ClassLoader.getSystemResource(IconSet.DELETE_ROW_GIF));
        return icon;
    }

    public static ImageIcon getDownIcon() {
        ImageIcon icon = null;
        icon = new ImageIcon(ClassLoader.getSystemResource(IconSet.DOWN_GIF));
        return icon;
    }

    public static ImageIcon getRowIcon() {
        ImageIcon icon = null;
        icon = new ImageIcon(ClassLoader.getSystemResource(IconSet.ROW_GIF));
        return icon;
    }

    public static ImageIcon getLargeIcon() {
        ImageIcon icon = null;
        icon = new ImageIcon(ClassLoader.getSystemResource(IconSet.LARGE_GIF));
        return icon;
    }

    public static ImageIcon getNewRowIcon() {
        ImageIcon icon = null;
        icon = new ImageIcon(ClassLoader.getSystemResource(IconSet.NEW_ROW_GIF));
        return icon;
    }

    public static ImageIcon getOtterWizard() {
        ImageIcon icon = null;
        icon = new ImageIcon(ClassLoader.getSystemResource(IconSet.WIZARD_JPG));
        return icon;
    }

    public static ImageIcon getSmallIcon() {
        ImageIcon icon = null;
        icon = new ImageIcon(ClassLoader.getSystemResource(IconSet.SMALL_GIF));
        return icon;
    }

    public static ImageIcon getUpIcon() {
        ImageIcon icon = null;
        icon = new ImageIcon(ClassLoader.getSystemResource(IconSet.UP_GIF));
        return icon;
    }

    public static ImageIcon getUndoIcon() {
        ImageIcon icon = null;
        icon = new ImageIcon(ClassLoader.getSystemResource(IconSet.UNDO_GIF));
        return icon;
    }
}
